﻿Namespace Roton

    Partial Public Class Environment
        Private Shared ReadOnly LineChars() As Byte = {
            &HF9, &HD0, &HD2, &HBA,
            &HB5, &HBC, &HBB, &HB9,
            &HC6, &HC8, &HC9, &HCC,
            &HCD, &HCA, &HCB, &HCE
        }

        Private Shared ReadOnly StarChars() As Byte = {
            &HB3, &H2F, &HC4, &H5C
        }

        Private Shared ReadOnly TransHChars() As Byte = {
            &H28, &H3C, &H28, &HB3,
            &H29, &H3E, &H29, &HB3
        }

        Private Shared ReadOnly TransVChars() As Byte = {
            &H5E, &H7E, &H5E, &H2D,
            &H76, &H5F, &H76, &H2D
        }

        Private Shared ReadOnly WebChars() As Byte = {
            &HFA, &HB3, &HB3, &HB3,
            &HC4, &HD9, &HBF, &HB4,
            &HC4, &HC0, &HDA, &HC3,
            &HC4, &HC1, &HC2, &HC5
        }

        Private Shared ReadOnly ColorStrings() As String = {
            "Black",
            "Blue",
            "Green",
            "Cyan",
            "Red",
            "Purple",
            "Yellow",
            "White"
        }

        ' dseg:0062
        Private Shared ReadOnly XVectorList4() As Integer = {
            0, 0, -1, 1
        }

        ' dseg:006A
        Private Shared ReadOnly YVectorList4() As Integer = {
            -1, 1, 0, 0
        }

        ' dseg:0042
        Private Shared ReadOnly XVectorList8() As Integer = {
            -1, 0, 1, 1, 1, 0, -1, -1
        }

        ' dseg:0052
        Private Shared ReadOnly YVectorList8() As Integer = {
            1, 1, 1, 0, -1, -1, -1, 0
        }

        Protected Enum RadiusType As Integer
            Update = 0
            Explode = 1
            Cleanup = 2
        End Enum

        Private Shared ReadOnly AboutText As String =
            "$This application uses" & Chr(13) &
            "$- Roton -" & Chr(13) &
            "$a ZZT simulation library" & Chr(13) &
            "$" & Chr(13) &
            "$Contact:" & Chr(13) &
            "$saxxonpike@gmail.com" & Chr(13) &
            "$" & Chr(13) &
            "$http://www.zzt.org"

        Public Sub Cheat(ByVal CheatString As String)
            ExecuteCheat(CheatString)
            StatusUpdate()
        End Sub

        Private Sub ExecuteCheat(ByVal CheatString As String)
            Dim Index As Integer
            Dim Condition As Boolean
            Dim TargetX As Integer
            Dim TargetY As Integer

            CheatString = CheatString.ToLower
            Condition = True

            If (CheatString.Length > 0) Then
                If (CheatString.Substring(0, 1) = "+") Then
                    CheatString = CheatString.Substring(1)
                    SetFlag(CheatString)
                ElseIf (CheatString.Substring(0, 1) = "-") Then
                    CheatString = CheatString.Substring(1)
                    ClearFlag(CheatString)
                    Condition = False
                End If
            End If

            Select Case CheatString
                Case "health"
                    World.Health += 50
                Case "ammo"
                    World.Ammo += Parameters.AmmoPerPickup
                Case "keys"
                    For Index = 0 To 6
                        World.Keys(Index) = True
                    Next
                Case "torches"
                    If (Parameters.TorchesEnabled) Then
                        World.Torches += 3
                    End If
                Case "time"
                    World.TimePassed -= 30
                Case "z"
                    If (Parameters.StonesEnabled) Then
                        World.Stones += 1
                    End If
                Case "noz"
                    If (Parameters.StonesEnabled) Then
                        World.Stones = -1
                    End If
                Case "gems"
                    World.Gems += 5
                Case "dark"
                    If (Parameters.TorchesEnabled) Then
                        CurrentBoard.IsDark = Condition
                        RedrawBoard()
                    End If
                Case "zap"
                    For Index = 0 To 3
                        TargetX = XVectorList4(Index) + PlayerX
                        TargetY = YVectorList4(Index) + PlayerY
                        DestroyAt(TargetX, TargetY)
                        ElementAt(TargetX, TargetY) = Library.GetElementFromID(ElementID.Empty)
                        UpdateAt(TargetX, TargetY)
                    Next
            End Select
            'playsound(10, sndCheat)
        End Sub

        Public Function Execute() As Boolean
            Dim Result As Boolean

            If (Debugger.IsAttached) Then
                ' debugger is enabled, disable error trapping
                Result = ExecuteInit()
            Else
                Try
                    Result = ExecuteInit()
                Catch ex As Exception
                    State.QuitZZT = True
                    If MsgBox("Game: " & World.Name & vbCrLf &
                           vbCrLf &
                           ex.Message & vbCrLf &
                           vbCrLf &
                           "Would you like to see a stack trace?",
                           MsgBoxStyle.YesNo,
                           "Internal Error") = MsgBoxResult.Yes Then
                        MsgBox(ex.StackTrace, , "Crash Stack Trace")
                    End If
                    Return False
                End Try
            End If

            'Video.WriteOverlay(0, 0, PlayerX & "," & PlayerY & "  ", &H8F)
            Return Result
        End Function

        Protected Function ExecuteMain() As Boolean
            Dim UpdatedScreen As Boolean = False
            Dim TargetX As Integer
            Dim TargetY As Integer
            Dim E As Element

            If (State.QuitZZT) Then
                Return UpdatedScreen
            End If

            If (World.Health > 0) Then
                State.GameWaitTime = State.GameSpeed << 1
            End If

            If (State.GameWaitTime = 0) Then
                State.GameWaitTime = 1
            End If

            If (Scroll.Visible) Then
                ReadInput()
                Scroll.Update()
                If (Not Scroll.Visible) AndAlso (Scroll.LineIndex >= 0) Then
                    ExecuteScrollClose(ScrollOwner, Scroll.LineIndex)
                End If
                Return (State.KeyPressed <> 0) OrElse (Scroll.Animating)
            End If

            If (State.GamePaused) Then
                E = Library.GetElementFromID(ElementID.Player)
                If (State.MainTimer Mod 25 = 0) Then
                    State.GamePausedBlink = Not State.GamePausedBlink
                    If (State.GamePausedBlink) Then
                        Video.Plot(PlayerX, PlayerY, New AnsiChar(E.Char, E.Color))
                    Else
                        With CurrentBoard.Things(0)
                            If (ElementAt(.X, .Y).ID = ElementID.Player) Then
                                Video.Plot(.X, .Y, New AnsiChar(32, 0))
                            Else
                                Video.Plot(.X, .Y, New AnsiChar(ElementAt(.X, .Y).Char, ColorAt(.X, .Y)))
                            End If
                        End With
                    End If
                    UpdatedScreen = True
                End If

                ReadInput()
                If (Input.GetKey = &H1B) Then
                    State.QuitZZT = True
                End If

                If (State.KeyVectorX <> 0) OrElse (State.KeyVectorY <> 0) Then
                    TargetX = PlayerX + State.KeyVectorX
                    TargetY = PlayerY + State.KeyVectorY
                    Interact(TargetX, TargetY, 0, State.KeyVectorX, State.KeyVectorY)
                    UpdatedScreen = True
                End If

                If (State.KeyVectorX <> 0) OrElse (State.KeyVectorY <> 0) Then
                    TargetX = PlayerX + State.KeyVectorX
                    TargetY = PlayerY + State.KeyVectorY
                    If (ElementAt(TargetX, TargetY).Floor) Then
                        If (Parameters.BuggyPassages) Then
                            If (ElementAt(PlayerX, PlayerY).ID = ElementID.Player) Then
                                MoveThing(0, TargetX, TargetY)
                            Else
                                TileAt(TargetX, TargetY) = New Tile(E, E.Color)
                                UpdateAt(PlayerX, PlayerY)
                                CurrentBoard.Things(0).X = TargetX
                                CurrentBoard.Things(0).Y = TargetY
                                UpdateAt(PlayerX, PlayerY)
                                Radius(PlayerX, PlayerY, RadiusType.Update)
                                Radius(PlayerX - State.KeyVectorX, PlayerY - State.KeyVectorY, RadiusType.Update)
                            End If
                        Else
                            If (ElementAt(PlayerX, PlayerY).ID = ElementID.Player) Then
                                MoveThing(0, TargetX, TargetY)
                            Else
                                UpdateAt(PlayerX, PlayerY)
                                CurrentBoard.Things(0).X = TargetX
                                CurrentBoard.Things(0).Y = TargetY
                                CurrentBoard.Things(0).UnderElement = ElementAt(TargetX, TargetY)
                                CurrentBoard.Things(0).UnderColor = ColorAt(TargetX, TargetY)
                                ElementAt(TargetX, TargetY) = Library.GetElementFromID(ElementID.Player)
                                ColorAt(TargetX, TargetY) = ElementAt(TargetX, TargetY).Color
                                UpdateAt(TargetX, TargetY)
                                Radius(TargetX, TargetY, RadiusType.Update)
                                Radius(TargetX - State.KeyVectorX, TargetY - State.KeyVectorY, RadiusType.Update)
                            End If
                        End If
                        State.RedrawHUD = True
                        State.GamePaused = False
                        State.GameTick = Random(100)
                        State.ActIndex = CurrentBoard.Things.Count + 1
                        World.SavedGame = True
                        UpdatedScreen = True
                    End If
                End If
            End If

            If (State.ActIndex < ThingCount) OrElse ((State.MainTimer Mod State.GameWaitTime) = 0) Then

                If (State.ActIndex >= ThingCount) Then
                    State.GameTick += 1
                    If (State.GameTick > &H1A4) Then
                        State.GameTick = 1
                    End If
                    State.ActIndex = 0
                    ReadInput()
                End If

                Do Until (State.ActIndex >= ThingCount) OrElse (Scroll.Visible) OrElse (State.BreakGameLoop) OrElse (State.GamePaused)
                    If (State.ActIndex < ThingCount) Then
                        With CurrentBoard.Things(State.ActIndex)
                            If (.Cycle <> 0) Then
                                If (State.ActIndex Mod .Cycle) = (State.GameTick Mod .Cycle) Then
                                    Act(State.ActIndex)
                                End If
                            End If
                        End With
                        State.ActIndex += 1
                    End If
                Loop

                If (State.ActIndex >= ThingCount) Then
                    If (Messenger.TicksLeft > 0) Then
                        Messenger.Update()
                        If (Messenger.TicksLeft = 0) Then
                            UpdateBorder()
                        End If
                    End If
                End If

                If (State.BreakGameLoop) Then
                    StopAudio()
                    Select Case State.PlayerElement.ID
                        Case ElementID.Player
                            If (World.Health <= 0) Then
                                ' show high score dialog
                            End If
                            State.QuitZZT = True
                        Case ElementID.Monitor
                            ' draw status line for title
                    End Select
                End If

                UpdatedScreen = True
            End If

            If (Not State.GamePaused) AndAlso (State.TimeLimitTicks > 0) Then
                State.TimeLimitTicks -= 1
            End If

            State.MainTimer += 1

            Return UpdatedScreen
        End Function

        Protected Function ExecuteInit() As Boolean
            Dim UpdatedScreen As Boolean = False

            If (State.EditorMode) Then
                State.GameWaitTime = State.GameSpeed << 1
                State.MainTimer += 1
                If ((State.MainTimer Mod State.GameWaitTime) = 0) Then
                    State.GameTick += 1
                    If (State.GameTick > &H1A4) Then
                        State.GameTick = 1
                    End If
                    For State.ActIndex = 0 To ThingCount - 1
                        With CurrentBoard.Things(State.ActIndex)
                            If (.Cycle <> 0) Then
                                If (State.ActIndex Mod .Cycle) = (State.GameTick Mod .Cycle) Then
                                    UpdateAt(.X, .Y)
                                End If
                            End If
                        End With
                    Next
                    Return True
                End If
                Return False
            End If

            State.BreakGameLoop = False

            Select Case State.Execution
                Case EnvironmentGameExecutionState.Init
                    State.StartBoard = World.Board
                    State.PlayerElement = Library.GetElementFromID(ElementID.Monitor)
                    SetBoard(0)
                    RedrawBoard()
                    State.Execution = EnvironmentGameExecutionState.TitleScreenInit
                    UpdatedScreen = True
                    State.RedrawHUD = True
                    ExecuteInit()
                Case EnvironmentGameExecutionState.TitleScreenInit
                    State.PlayerElement = Library.GetElementFromID(ElementID.Monitor)
                    State.BreakGameLoop = False
                    State.GameTick = Random(100)
                    State.ActIndex = CurrentBoard.Things.Count + 1
                    State.Execution = EnvironmentGameExecutionState.TitleScreenPreLoop
                    UpdatedScreen = ExecuteInit()
                Case EnvironmentGameExecutionState.TitleScreenPreLoop
                    TileAt(PlayerX, PlayerY) = New Tile(State.PlayerElement, State.PlayerElement.Color)
                    UpdateAt(PlayerX, PlayerY)
                    State.GamePaused = False
                    State.Execution = EnvironmentGameExecutionState.TitleScreen
                    State.RedrawHUD = True
                    UpdatedScreen = ExecuteInit()
                Case EnvironmentGameExecutionState.TitleScreen
                    UpdatedScreen = ExecuteMain()
                    If (State.BreakGameLoop) Then
                        Select Case State.KeyPressed
                            Case &H57 'W
                            Case &H50 'P
                                State.Execution = EnvironmentGameExecutionState.GameInit
                                SetBoard(State.StartBoard)
                            Case &H41 'A
                                ExecuteScroll(Nothing, "About", AboutText)
                            Case &H45 'E
                            Case &H53 'S
                            Case &H52 'R
                            Case &H48 'H
                            Case 191 'cheat
                            Case &H1B, &H51 'esc, Q
                                State.QuitZZT = True
                            Case Else
                                Debug.Print(State.KeyPressed)
                        End Select
                        If (State.Execution = EnvironmentGameExecutionState.TitleScreen) Then
                            State.Execution = EnvironmentGameExecutionState.TitleScreenPreLoop
                        Else
                            ExecuteInit()
                            UpdatedScreen = True
                        End If
                    End If
                Case EnvironmentGameExecutionState.GameInit
                    State.PlayerElement = Library.GetElementFromID(ElementID.Player)
                    State.GamePaused = True
                    State.Execution = EnvironmentGameExecutionState.Game
                    EnterBoard()
                    RedrawBoard()
                    UpdatedScreen = True
                    State.RedrawHUD = True
                    ExecuteInit()
                Case EnvironmentGameExecutionState.Game
                    UpdatedScreen = ExecuteMain()
                Case EnvironmentGameExecutionState.Quit
                    ' return to title screen
            End Select

            Return UpdatedScreen
        End Function

        Protected Sub ReadInput()
            Input.Poll()
            State.KeyArrow = False
            State.KeyVectorX = 0
            State.KeyVectorY = 0
            State.KeyShift = Input.GetShift
            State.KeyPressed = Input.GetKey
            Select Case CType(State.KeyPressed, Windows.Forms.Keys)
                Case Keys.Left
                    State.KeyArrow = True
                    State.KeyVectorX = -1
                    State.KeyVectorY = 0
                Case Keys.Up
                    State.KeyArrow = True
                    State.KeyVectorX = 0
                    State.KeyVectorY = -1
                Case Keys.Down
                    State.KeyArrow = True
                    State.KeyVectorX = 0
                    State.KeyVectorY = 1
                Case Keys.Right
                    State.KeyArrow = True
                    State.KeyVectorX = 1
                    State.KeyVectorY = 0
            End Select
            If (State.KeyVectorX <> 0) OrElse (State.KeyVectorY <> 0) Then
                State.LastKeyVectorX = State.KeyVectorX
                State.LastKeyVectorY = State.KeyVectorY
            End If
        End Sub

        Protected Sub StatusUpdate()
            State.UpdateHUD = True
        End Sub

        Protected Sub StopAudio()

        End Sub

        Protected Sub Act(ByVal Index As Integer)
            Dim T As Thing = CurrentBoard.Things(Index)
            Dim E As Element = ElementAt(T.X, T.Y)

            Select Case E.ID
                Case ElementID.Bear
                    ActBear(Index)
                Case ElementID.BlinkWall
                    ActBlinkWall(Index)
                Case ElementID.Bomb
                    ActBomb(Index)
                Case ElementID.Bullet
                    ActBullet(Index)
                Case ElementID.Clockwise
                    ActClockwise(Index)
                Case ElementID.Counter
                    ActCounter(Index)
                Case ElementID.DragonPup
                    ActDragonPup(Index)
                Case ElementID.Duplicator
                    ActDuplicator(Index)
                Case ElementID.Head
                    ActHead(Index)
                Case ElementID.Lion
                    ActLion(Index)
                Case ElementID.Monitor
                    ActMonitor(Index)
                Case ElementID.Object
                    ActObject(Index)
                Case ElementID.Pairer
                    ActPairer(Index)
                Case ElementID.Player
                    ActPlayer(Index)
                Case ElementID.Pusher
                    ActPusher(Index)
                Case ElementID.Roton
                    ActRoton(Index)
                Case ElementID.Ruffian
                    ActRuffian(Index)
                Case ElementID.Scroll
                    ActScroll(Index)
                Case ElementID.Segment
                    ActSegment(Index)
                Case ElementID.Shark
                    ActShark(Index)
                Case ElementID.Slime
                    ActSlime(Index)
                Case ElementID.Spider
                    ActSpider(Index)
                Case ElementID.SpinningGun
                    ActSpinningGun(Index)
                Case ElementID.Star
                    ActStar(Index)
                Case ElementID.Stone
                    ActStone(Index)
                Case ElementID.Tiger
                    ActTiger(Index)
                Case ElementID.Transporter
                    ActTransporter(Index)
            End Select
        End Sub

        Protected Sub ActBear(ByVal Index As Integer)
            Dim TargetX As Integer
            Dim TargetY As Integer
            Dim V As Vector
            Dim E As Element
            Dim T As Thing = GetFixedThing(Index)

            If (PlayerX = T.X) OrElse (8 - T.P1 < AbsDiff(PlayerY, T.Y)) Then
                If (8 - T.P1 < AbsDiff(PlayerX, T.X)) Then
                    V.X = 0
                    V.Y = 0
                Else
                    V.X = 0
                    V.Y = PosNeg(PlayerY - T.Y)
                End If
            Else
                V.X = PosNeg(PlayerX - T.X)
                V.Y = 0
            End If
            TargetX = T.X + V.X
            TargetY = T.Y + V.Y
            E = ElementAt(TargetX, TargetY)
            If (E.Floor) Then
                MoveThing(Index, TargetX, TargetY)
            ElseIf (E.ID = ElementID.Player) OrElse (E.ID = ElementID.Breakable) Then
                Attack(Index, TargetX, TargetY)
            End If
        End Sub

        Protected Sub ActBlinkWall(ByVal Index As Integer)
            Dim Blocked As Boolean
            Dim TargetX As Integer
            Dim TargetY As Integer
            Dim E As Element
            Dim Color As Integer
            Dim I As Integer
            Dim T As Thing = GetFixedThing(Index)

            With T
                If (.P3 = 0) Then
                    .P3 = .P1 + 1
                End If
                If (.P3 = 1) Then
                    .P3 = (.P2 * 2) + 1
                    TargetX = .X + .XStep
                    TargetY = .Y + .YStep
                    If (.XStep = 0) Then
                        E = Library.GetElementFromID(ElementID.BlinkRayV)
                    Else
                        E = Library.GetElementFromID(ElementID.BlinkRayH)
                    End If
                    Color = ColorAt(T.X, T.Y)
                    Do While (ElementAt(TargetX, TargetY).ID = E.ID) AndAlso (ColorAt(TargetX, TargetY) = Color)
                        ElementAt(TargetX, TargetY) = Library.GetElementFromID(ElementID.Empty)
                        UpdateAt(TargetX, TargetY)
                        TargetX += .XStep
                        TargetY += .YStep
                    Loop
                    If (TargetX = .X + .XStep) AndAlso (TargetY = .Y + .YStep) Then
                        Blocked = False
                        Do
                            If (ElementAt(TargetX, TargetY).Destructible) Then
                                DestroyAt(TargetX, TargetY)
                            End If
                            If (ElementAt(TargetX, TargetY).ID = ElementID.Player) Then
                                I = ThingIndexAt(TargetX, TargetY)
                                If (.YStep = 0) Then
                                    If (ElementAt(TargetX, TargetY - 1).ID = ElementID.Empty) Then
                                        MoveThing(I, TargetX, TargetY - 1)
                                    ElseIf (ElementAt(TargetX, TargetY + 1).ID = ElementID.Empty) Then
                                        MoveThing(I, TargetX, TargetY + 1)
                                    End If
                                Else
                                    If (ElementAt(TargetX + 1, TargetY).ID = ElementID.Empty) Then
                                        MoveThing(I, TargetX + 1, TargetY)
                                    ElseIf (ElementAt(TargetX - 1, TargetY).ID = ElementID.Empty) Then
                                        MoveThing(I, TargetX + 1, TargetY)
                                    End If
                                End If
                                If (ElementAt(TargetX, TargetY).ID = ElementID.Player) Then
                                    Do Until (World.Health <= 0)
                                        HarmThing(0)
                                    Loop
                                    Blocked = True
                                End If
                            End If
                            If (ElementAt(TargetX, TargetY).ID = ElementID.Empty) Then
                                TileAt(TargetX, TargetY) = New Tile(E, Color)
                                UpdateAt(TargetX, TargetY)
                            Else
                                Blocked = True
                            End If
                            TargetX += .XStep
                            TargetY += .YStep
                        Loop Until (Blocked)
                    End If
                Else
                    .P3 -= 1
                End If
            End With
        End Sub

        Protected Sub ActBomb(ByVal Index As Integer)
            Dim TargetX As Integer
            Dim TargetY As Integer
            Dim T As Thing = GetFixedThing(Index)

            If (T.P1 > 0) Then
                T.P1 -= 1
                UpdateAt(T.X, T.Y)
                If (T.P1 = 1) Then
                    'playsound(sndbombexplode)
                    Radius(T.X, T.Y, RadiusType.Explode)
                ElseIf (T.P1 = 0) Then
                    TargetX = T.X
                    TargetY = T.Y
                    RemoveThing(Index)
                    Radius(TargetX, TargetY, RadiusType.Cleanup)
                Else
                    If (T.P1 Mod 2 = 0) Then
                        'playsound(sndbombtock)
                    Else
                        'playsound(sndbombtick)
                    End If
                End If
            End If
        End Sub

        Protected Sub ActBullet(ByVal Index As Integer)
            Dim Ricochet As Boolean
            Dim TargetX As Integer
            Dim TargetY As Integer
            Dim E As Element
            Dim I As Integer
            Dim T As Thing = GetFixedThing(Index)

            Ricochet = True
            Do
                TargetX = T.X + T.XStep
                TargetY = T.Y + T.YStep
                E = ElementAt(TargetX, TargetY)
                If (E.Floor) OrElse (E.ID = ElementID.Water) OrElse (E.ID = ElementID.Lava) Then
                    MoveThing(Index, TargetX, TargetY)
                    Exit Do
                End If
                If (E.ID = ElementID.Ricochet) AndAlso (Ricochet) Then
                    'playsound(1, ricochet)
                    T.XStep = -T.XStep
                    T.YStep = -T.YStep
                    Ricochet = False
                    Continue Do
                End If
                If (E.ID <> ElementID.Breakable) Then
                    If (Not E.Destructible) OrElse ((E.ID <> ElementID.Player) AndAlso (T.P1 <> 0)) Then
                        If (Ricochet) AndAlso (ElementAt(T.X + T.YStep, T.Y + T.XStep).ID = ElementID.Ricochet) Then
                            'playsound(1, ricochet)
                            I = T.XStep
                            T.XStep = -T.YStep
                            T.YStep = -I
                            Ricochet = False
                            Continue Do
                        ElseIf (Ricochet) AndAlso (ElementAt(T.X - T.YStep, T.Y - T.XStep).ID = ElementID.Ricochet) Then
                            'playsound(1, ricochet)
                            I = T.XStep
                            T.XStep = T.YStep
                            T.YStep = I
                            Ricochet = False
                            Continue Do
                        Else
                            RemoveThing(Index)
                            State.ActIndex -= 1
                            If (E.ID = ElementID.Object) Then
                                'SHOT
                                SendLabel(ThingAt(TargetX, TargetY), OOPCodeSet(76), False, True)
                            End If
                            Exit Do
                        End If
                    End If
                End If
                If (E.Score > 0) Then
                    World.Score += E.Score
                    StatusUpdate()
                End If
                Attack(Index, TargetX, TargetY)
                Exit Do
            Loop
        End Sub

        Protected Sub ActClockwise(ByVal Index As Integer)
            Dim T As Thing = GetFixedThing(Index)
            UpdateAt(T.X, T.Y)
            ConveyorMove(T.X, T.Y, -1)
        End Sub

        Protected Sub ActCounter(ByVal Index As Integer)
            Dim T As Thing = GetFixedThing(Index)
            UpdateAt(T.X, T.Y)
            ConveyorMove(T.X, T.Y, 1)
        End Sub

        Protected Sub ActDragonPup(ByVal Index As Integer)
            Dim T As Thing = GetFixedThing(Index)
            UpdateAt(T.X, T.Y)
        End Sub

        Protected Sub ActDuplicator(ByVal Index As Integer)
            Dim SourceX As Integer
            Dim SourceY As Integer
            Dim TargetX As Integer
            Dim TargetY As Integer
            Dim I As Integer
            Dim T As Thing = GetFixedThing(Index)

            With T
                SourceX = .X + .XStep
                SourceY = .Y + .YStep
                TargetX = .X - .XStep
                TargetY = .Y - .YStep
                If (.P1 > 4) Then
                    If (ElementAt(TargetX, TargetY).ID = ElementID.Player) Then
                        Interact(SourceX, SourceY, 0, State.KeyVectorX, State.KeyVectorY)
                        T = GetFixedThing(Index)
                    Else
                        If (ElementAt(TargetX, TargetY).ID <> ElementID.Empty) Then
                            Push(TargetX, TargetY, New Vector(-.XStep, -.YStep))
                            If (Not Parameters.KoopoBug) Then
                                Index = CurrentBoard.Things.IndexOf(T)
                            End If
                            T = GetFixedThing(Index)
                        End If
                        If (ElementAt(TargetX, TargetY).ID = ElementID.Empty) Then
                            I = ThingIndexAt(SourceX, SourceY)
                            If (I > 0) Then
                                If (ThingCount < Parameters.MaxThings) Then
                                    With TileAt(SourceX, SourceY)
                                        SpawnThing(TargetX, TargetY, .Element, .Color, .Element.Cycle, CurrentBoard.Things(I))
                                        UpdateAt(TargetX, TargetY)
                                    End With
                                End If
                            ElseIf (I <> 0) Then
                                TileAt(TargetX, TargetY) = TileAt(SourceX, SourceY)
                                UpdateAt(TargetX, TargetY)
                            End If
                            'playsound(3, dupe)
                        Else
                            'playsound(3, dupe fail)
                        End If
                    End If
                    .P1 = 0
                Else
                    .P1 += 1
                End If
                UpdateAt(.X, .Y)
                .Cycle = (9 - .P2) * 3
            End With
        End Sub

        Protected Sub ActHead(ByVal Index As Integer)
            Dim E As Element
            Dim V As Vector
            Dim I As Integer
            Dim SourceX As Integer
            Dim SourceY As Integer
            Dim T As Thing = GetFixedThing(Index)

            If (PlayerX = T.X) AndAlso (T.P1 > Random(10)) Then
                T.XStep = 0
                T.YStep = PosNeg(PlayerY - T.Y)
            ElseIf (PlayerY = T.Y) AndAlso (T.P1 > Random(10)) Then
                T.XStep = PosNeg(PlayerX - T.X)
                T.YStep = 0
            ElseIf ((T.XStep = 0) AndAlso (T.YStep = 0)) OrElse (T.P2 > (Random(10) << 2)) Then
                T.Vector = Rnd()
            End If
            E = ElementAt(T.X + T.XStep, T.Y + T.YStep)
            V = T.Vector
            If (Not E.Floor) AndAlso (E.ID <> ElementID.Player) Then
                T.Vector = RndP(T.Vector)
                E = ElementAt(T.X + T.XStep, T.Y + T.YStep)
                If (Not E.Floor) AndAlso (E.ID <> ElementID.Player) Then
                    T.Vector = T.Vector.Opp
                    E = ElementAt(T.X + T.XStep, T.Y + T.YStep)
                    If (Not E.Floor) AndAlso (E.ID <> ElementID.Player) Then
                        T.Vector = V.Opp
                        E = ElementAt(T.X + T.XStep, T.Y + T.YStep)
                        If (Not E.Floor) AndAlso (E.ID <> ElementID.Player) Then
                            T.XStep = 0
                            T.YStep = 0
                        End If
                    End If
                End If
            End If
            If (T.XStep = 0) AndAlso (T.YStep = 0) Then
                ElementAt(T.X, T.Y) = Library.GetElementFromID(ElementID.Segment)
                UpdateAt(T.X, T.Y)
                'T.Leader = -1
                Do
                    With CurrentBoard.Things(Index)
                        I = .Follower
                        .Follower = .Leader
                        .Leader = I
                    End With
                    If (I > 0) Then
                        Index = I
                    Else
                        Exit Do
                    End If
                Loop
                T = CurrentBoard.Things(Index)
                ElementAt(T.X, T.Y) = Library.GetElementFromID(ElementID.Head)
                UpdateAt(T.X, T.Y)
            Else
                If (ElementAt(T.X + T.XStep, T.Y + T.YStep).ID = ElementID.Player) Then
                    If (T.Follower > 0) Then
                        With CurrentBoard.Things(T.Follower)
                            ElementAt(.X, .Y) = Library.GetElementFromID(ElementID.Head)
                            .Leader = -1
                            UpdateAt(.X, .Y)
                        End With
                    End If
                    T.Follower = -1
                    T.Leader = -1
                    Attack(Index, T.X + T.XStep, T.Y + T.YStep)
                Else
                    MoveThing(Index, T.X + T.XStep, T.Y + T.YStep)
                    Do
                        T = CurrentBoard.Things(Index)
                        SourceX = T.X - T.XStep
                        SourceY = T.Y - T.YStep
                        V.X = T.XStep
                        V.Y = T.YStep
                        If (T.Follower < 0) Then
                            If (ElementAt(SourceX - V.X, SourceY - V.Y).ID = ElementID.Segment) AndAlso (ThingAt(SourceX - V.X, SourceY - V.Y).Leader <= 0) Then
                                T.Follower = ThingIndexAt(SourceX - V.X, SourceY - V.Y)
                            ElseIf (ElementAt(SourceX - V.Y, SourceY - V.X).ID = ElementID.Segment) AndAlso (ThingAt(SourceX - V.Y, SourceY - V.X).Leader <= 0) Then
                                T.Follower = ThingIndexAt(SourceX - V.Y, SourceY - V.X)
                            ElseIf (ElementAt(SourceX + V.Y, SourceY + V.X).ID = ElementID.Segment) AndAlso (ThingAt(SourceX + V.Y, SourceY + V.X).Leader <= 0) Then
                                T.Follower = ThingIndexAt(SourceX + V.Y, SourceY + V.X)
                            Else
                                T.Follower = -1
                            End If
                        End If
                        If (T.Follower > 0) Then
                            With CurrentBoard.Things(T.Follower)
                                .Leader = Index
                                .P1 = T.P1
                                .P2 = T.P2
                                .XStep = SourceX - .X
                                .YStep = SourceY - .Y
                            End With
                            MoveThing(T.Follower, SourceX, SourceY)
                        End If
                        Index = T.Follower
                    Loop Until (Index <= 0)
                End If
            End If
        End Sub

        Protected Sub ActLion(ByVal Index As Integer)
            Dim TargetX As Integer
            Dim TargetY As Integer
            Dim V As Vector
            Dim E As Element
            Dim T As Thing = GetFixedThing(Index)

            If (T.P1 >= RNG.Next(10)) Then
                V = Seek(T.X, T.Y)
            Else
                V = Rnd()
            End If
            TargetX = T.X + V.X
            TargetY = T.Y + V.Y
            E = ElementAt(TargetX, TargetY)
            If (E.Floor) Then
                MoveThing(Index, TargetX, TargetY)
            ElseIf (E.ID = ElementID.Player) Then
                Attack(Index, TargetX, TargetY)
            End If
        End Sub

        Protected Sub ActMonitor(ByVal Index As Integer)
            Dim T As Thing = GetFixedThing(Index)
            If (State.KeyPressed <> 0) Then
                State.BreakGameLoop = True
            End If
            MoveRiver(Index)
        End Sub

        Protected Sub ActObject(ByVal Index As Integer)
            Dim TargetX As Integer
            Dim TargetY As Integer
            Dim Dead As Boolean = False
            Dim T As Thing = GetFixedThing(Index)

            If (Not (T.Code Is Nothing)) AndAlso (T.CurrentInstruction >= 0) AndAlso ((Not Parameters.MultiMovement) OrElse (T.P2 = 0)) Then
                Dead = ExecuteOOP(Index, T.CurrentInstruction, "Interaction")
            End If
            If (Not Dead) Then
                If (T.XStep <> 0) OrElse (T.YStep <> 0) Then
                    TargetX = T.X + T.XStep
                    TargetY = T.Y + T.YStep
                    If (Parameters.MultiMovement) AndAlso (Not ElementAt(TargetX, TargetY).Floor) Then
                        Push(TargetX, TargetY, T.Vector)
                        If (Not Parameters.KoopoBug) Then
                            Index = CurrentBoard.Things.IndexOf(T)
                        End If
                        T = GetFixedThing(Index)
                    End If
                    If (ElementAt(TargetX, TargetY).Floor) Then
                        MoveThing(Index, TargetX, TargetY)
                        If ((Parameters.MultiMovement) AndAlso (T.P2 <> 0)) Then
                            T.P2 -= 1
                            If (T.P2 = 0) Then
                                T.XStep = 0
                                T.YStep = 0
                            End If
                        End If
                    Else
                        If (Not Parameters.MultiMovement) OrElse (T.P2 = 0) Then
                            'THUD
                            SendLabel(T, OOPCodeSet(71), False, True)
                        End If
                    End If
                Else
                    If ((Parameters.MultiMovement) AndAlso (T.P2 <> 0)) Then
                        T.P2 -= 1
                    End If
                End If
            End If
        End Sub

        Protected Sub ActPairer(ByVal Index As Integer)
            'pairers do nothing
        End Sub

        Protected Sub ActPlayer(ByVal Index As Integer)
            Dim E As Element
            Dim Count As Integer
            Dim TargetX As Integer
            Dim TargetY As Integer
            Dim OldBoard As Integer
            Dim T As Thing = GetFixedThing(Index)

            UpdateAt(T.X, T.Y)
            E = Library.GetElementFromID(ElementID.Player)
            If (World.EnergyCycles > 0) Then
                With E
                    If (.Char = 2) Then
                        .Char = 1
                    Else
                        .Char = 2
                    End If
                End With
                If (State.GameTick Mod 2 = 0) Then
                    ColorAt(T.X, T.Y) = (((State.GameTick Mod 7) + 1) << 4) + &HF
                Else
                    ColorAt(T.X, T.Y) = &HF
                End If
                UpdateAt(T.X, T.Y)
            ElseIf (ColorAt(T.X, T.Y) <> E.Color) OrElse (E.Char <> 2) Then
                E.Char = 2
                If (Parameters.ForcePlayerColor) Then
                    ColorAt(T.X, T.Y) = E.Color
                End If
                UpdateAt(T.X, T.Y)
            End If
            If (World.Health <= 0) Then
                State.KeyVectorX = 0
                State.KeyVectorY = 0
                State.KeyShift = False
                If (Messenger.TicksLeft = 0) Then
                    SetMessage(&H7D00, Parameters.GameOverMessage)
                End If
                State.GameWaitTime = 1
            End If
            If (State.KeyPressed = &H20) Then
                State.KeyVectorX = State.LastKeyVectorX
                State.KeyVectorY = State.LastKeyVectorY
                State.KeyShift = True
            End If
            If (State.KeyShift) OrElse (State.KeyPressed = &H20) Then
                If (State.KeyVectorX <> 0) OrElse (State.KeyVectorY <> 0) Then
                    If (CurrentBoard.MaxShots > 0) Then
                        If (World.Ammo > 0) Then
                            Count = 0
                            For I = 0 To ThingCount - 1
                                With CurrentBoard.Things(I)
                                    If (ElementAt(.X, .Y).ID = ElementID.Bullet) Then
                                        If (.P1 = 0) Then
                                            Count += 1
                                        End If
                                    End If
                                End With
                            Next
                            If (Count < CurrentBoard.MaxShots) Then
                                If SpawnProjectile(Library.GetElementFromID(ElementID.Bullet), T.X, T.Y, New Vector(State.KeyVectorX, State.KeyVectorY), False) Then
                                    World.Ammo -= 1
                                    StatusUpdate()
                                    'playsound(2,sndPlayerShoot)
                                End If
                            End If
                        Else
                            If (State.AlertNoAmmo) Then
                                SetMessage(&HC8, Parameters.NoAmmoMessage)
                                State.AlertNoAmmo = False
                            End If
                        End If
                    Else
                        If (State.AlertNoShoot) Then
                            SetMessage(&HC8, Parameters.CantShootMessage)
                            State.AlertNoShoot = False
                        End If
                    End If
                End If
                State.KeyVectorX = 0
                State.KeyVectorY = 0
            Else
                If (State.KeyVectorX <> 0) OrElse (State.KeyVectorY <> 0) Then
                    TargetX = T.X + State.KeyVectorX
                    TargetY = T.Y + State.KeyVectorY
                    OldBoard = World.Board
                    Interact(TargetX, TargetY, 0, State.KeyVectorX, State.KeyVectorY)
                    T = GetFixedThing(Index)
                    'If (OldBoard <> World.Board) Then
                    '    State.ActIndex = 0
                    '    T = CurrentBoard.Things(0)
                    '    Return
                    'End If
                    If (State.KeyVectorX <> 0) OrElse (State.KeyVectorY <> 0) Then
                        TargetX = T.X + State.KeyVectorX
                        TargetY = T.Y + State.KeyVectorY
                        If (Not State.GameQuiet) Then
                            ' player tick sound
                        End If
                        If (ElementAt(TargetX, TargetY).Floor) Then
                            MoveThing(0, TargetX, TargetY)
                        End If
                    End If
                End If
            End If

            Select Case State.KeyPressed
                Case &H54 'T
                    If (Parameters.TorchesEnabled) AndAlso (World.TorchCycles <= 0) Then
                        If (World.Torches > 0) Then
                            If (CurrentBoard.IsDark) Then
                                World.Torches -= 1
                                World.TorchCycles = 200
                                StatusUpdate()
                                Radius(T.X, T.Y, RadiusType.Update)
                            Else
                                If (State.AlertNotDark) Then
                                    SetMessage(&HC8, Parameters.NotDarkMessage)
                                    State.AlertNotDark = False
                                End If
                            End If
                        Else
                            If (State.AlertNoTorch) Then
                                SetMessage(&HC8, Parameters.NoTorchesMessage)
                                State.AlertNoTorch = False
                            End If
                        End If
                    End If
                Case &H1B, &H51 'esc, Q
                    State.QuitZZT = True
                Case &H53 'S
                    'save game
                Case &H52 'R
                    'restore game
                Case &H50 'P
                    If (World.Health > 0) Then
                        State.GamePaused = True
                        State.UpdateHUD = True
                    End If
                Case &H42 'B
                    State.GameQuiet = Not State.GameQuiet
                    StopAudio()
                    StatusUpdate()
                    State.KeyPressed = &H20
                Case &H48 'H
                    If (Parameters.HintsEnabled) Then
                        'ALL:HINT
                        SendLabel(Player, OOPCodeSet(28) & ":" & OOPCodeSet(75), False, False)
                    End If
                Case &H46 'F
                    'order form
                Case &HBF '?
                    If (State.KeyShift) Then
                        'cheat
                    End If
            End Select
            If (World.TorchCycles > 0) Then
                World.TorchCycles -= 1
                If (World.TorchCycles <= 0) Then
                    Radius(T.X, T.Y, RadiusType.Update)
                    'playsound(torch out)
                End If
                If ((World.TorchCycles Mod 50) = 0) Then
                    StatusUpdate()
                End If
            End If
            If (World.EnergyCycles > 0) Then
                World.EnergyCycles -= 1
                If (World.EnergyCycles = 10) Then
                    'playsound(9,energy out)
                ElseIf (World.EnergyCycles = 0) Then
                    ColorAt(T.X, T.Y) = State.PlayerElement.Color
                    UpdateAt(T.X, T.Y)
                End If
            End If
            If (CurrentBoard.TimeLimit > 0) AndAlso (World.Health > 0) Then
                World.TimePassed = CurrentBoard.TimeLimit - (State.TimeLimitTicks \ 100)
                If (CurrentBoard.TimeLimit - World.TimePassed = 10) Then
                    SetMessage(&HC8, Parameters.NoTimeMessage)
                    'playsound(3,time low)
                ElseIf (CurrentBoard.TimeLimit = World.TimePassed) Then
                    HarmThing(0)
                End If
                StatusUpdate()
            End If
            If (Parameters.RiverEnabled) Then
                MoveRiver(Index)
            End If
        End Sub

        Protected Sub ActPusher(ByVal Index As Integer)
            Dim TargetX As Integer
            Dim TargetY As Integer
            Dim V As Vector
            Dim T As Thing = GetFixedThing(Index)

            TargetX = T.X + T.XStep
            TargetY = T.Y + T.YStep
            V = T.Vector
            If (Not ElementAt(TargetX, TargetY).Floor) Then
                Push(TargetX, TargetY, V)
                If (Not Parameters.KoopoBug) Then
                    Index = CurrentBoard.Things.IndexOf(T)
                End If
                T = GetFixedThing(Index)
            End If
            If (ElementAt(TargetX, TargetY).Floor) Then
                MoveThing(Index, TargetX, TargetY)
                'playsound(2, push)
            End If
        End Sub

        Protected Sub ActRoton(ByVal Index As Integer)
            Dim TargetX As Integer
            Dim TargetY As Integer
            Dim I As Integer
            Dim T As Thing = GetFixedThing(Index)

            'T.P3 -= 1
            'If (T.P3 < (-T.P2 Mod 10)) Then
            '    T.P3 = (T.P2 * 10) + Random(10)
            'End If
            T.Vector = Seek(T.X, T.Y)
            If (T.P1 <= Random(10)) Then
                I = T.XStep
                T.XStep = -PosNeg(T.P2) * T.YStep
                T.YStep = PosNeg(T.P2) * I
            End If
            TargetX = T.X + T.XStep
            TargetY = T.Y + T.YStep
            With ElementAt(TargetX, TargetY)
                If (.Floor) Then
                    MoveThing(Index, TargetX, TargetY)
                ElseIf (.ID = ElementID.Player) Then
                    Attack(Index, TargetX, TargetY)
                End If
            End With
        End Sub

        Protected Sub ActRuffian(ByVal Index As Integer)
            Dim TargetX As Integer
            Dim TargetY As Integer
            Dim E As Element
            Dim T As Thing = GetFixedThing(Index)

            If (T.XStep <> 0) OrElse (T.YStep <> 0) Then
                If (PlayerX = T.X) OrElse (PlayerY = T.Y) Then
                    If (T.P1 >= Random(9)) Then
                        With Seek(T.X, T.Y)
                            T.XStep = .X
                            T.YStep = .Y
                        End With
                    End If
                End If
                TargetX = T.X + T.XStep
                TargetY = T.Y + T.YStep
                E = ElementAt(TargetX, TargetY)
                If (E.ID = ElementID.Player) Then
                    Attack(Index, TargetX, TargetY)
                ElseIf (E.Floor) Then
                    MoveThing(Index, TargetX, TargetY)
                    If (T.P2 + 8 <= Random(17)) Then
                        T.XStep = 0
                        T.YStep = 0
                    End If
                Else
                    T.XStep = 0
                    T.YStep = 0
                End If
            Else
                If (T.P2 + 8 <= Random(17)) Then
                    If (T.P1 >= Random(9)) Then
                        T.Vector = Seek(T.X, T.Y)
                    Else
                        T.Vector = Rnd()
                    End If
                End If
            End If
        End Sub

        Protected Sub ActScroll(ByVal Index As Integer)
            Dim I As Integer
            Dim T As Thing = GetFixedThing(Index)

            I = ColorAt(T.X, T.Y) + 1
            If (I > &HF) Then
                I = 9
            End If
            ColorAt(T.X, T.Y) = I
            UpdateAt(T.X, T.Y)
        End Sub

        Protected Sub ActSegment(ByVal Index As Integer)
            Dim T As Thing = GetFixedThing(Index)
            With T
                If (.Leader = -1) Then
                    .Leader = -2
                ElseIf (.Leader = -2) Then
                    ElementAt(T.X, T.Y) = Library.GetElementFromID(ElementID.Head)
                End If
            End With
        End Sub

        Protected Sub ActShark(ByVal Index As Integer)
            Dim TargetX As Integer
            Dim TargetY As Integer
            Dim V As Vector
            Dim E As Element
            Dim T As Thing = GetFixedThing(Index)

            With T
                If .P1 >= Random(10) Then
                    V = Seek(.X, .Y)
                Else
                    V = Rnd()
                End If
                TargetX = V.X + .X
                TargetY = V.Y + .Y
                E = ElementAt(TargetX, TargetY)
                Select Case E.ID
                    Case ElementID.Water, ElementID.Lava
                        MoveThing(Index, TargetX, TargetY)
                    Case ElementID.Player
                        Attack(Index, TargetX, TargetY)
                End Select
            End With
        End Sub

        Protected Sub ActSlime(ByVal Index As Integer)
            Dim SourceX As Integer
            Dim SourceY As Integer
            Dim Color As Integer
            Dim Count As Integer
            Dim TargetX As Integer
            Dim TargetY As Integer
            Dim E As Element = Library.GetElementFromID(ElementID.Slime)
            Dim T As Thing = GetFixedThing(Index)

            With T
                Count = 0
                If (.P1 >= .P2) Then
                    Color = ColorAt(.X, .Y)
                    T.P1 = 0
                    SourceX = .X
                    SourceY = .Y
                    For I = 0 To 3
                        TargetX = SourceX + XVectorList4(I)
                        TargetY = SourceY + YVectorList4(I)
                        If (ElementAt(TargetX, TargetY).Floor) Then
                            If (Count = 0) Then
                                MoveThing(Index, TargetX, TargetY)
                                TileAt(SourceX, SourceY) = New Tile(Library.GetElementFromID(ElementID.Breakable), Color)
                                UpdateAt(SourceX, SourceY)
                            Else
                                SpawnThing(TargetX, TargetY, E, Color, E.Cycle, Nothing)
                                With CurrentBoard.Things(ThingCount - 1)
                                    .P2 = T.P2
                                End With
                            End If
                            Count += 1
                        End If
                    Next
                    If (Count = 0) Then
                        RemoveThing(Index)
                        TileAt(SourceX, SourceY) = New Tile(Library.GetElementFromID(ElementID.Breakable), Color)
                        UpdateAt(SourceX, SourceY)
                    End If
                Else
                    .P1 += 1
                End If
            End With
        End Sub

        Protected Sub ActSpider(ByVal Index As Integer)
            Dim V As Vector
            Dim I As Integer
            Dim T As Thing = GetFixedThing(Index)

            If (T.P1 <= Random(10)) Then
                V = Rnd()
            Else
                V = Seek(T.X, T.Y)
            End If
            If Not (ActSpiderMove(V.X, V.Y, Index)) Then
                I = (Random(2) << 1) - 1
                If Not (ActSpiderMove(V.Y * I, V.X * I, Index)) Then
                    If Not (ActSpiderMove(-V.Y * I, -V.X * I, Index)) Then
                        ActSpiderMove(-V.X, -V.Y, Index)
                    End If
                End If
            End If
        End Sub

        Protected Function ActSpiderMove(ByVal VectorX As Integer, ByVal VectorY As Integer, ByVal Index As Integer) As Boolean
            Dim Result As Boolean = False
            Dim TargetX As Integer
            Dim TargetY As Integer
            Dim T As Thing = GetFixedThing(Index)

            TargetX = T.X + VectorX
            TargetY = T.Y + VectorY
            With ElementAt(TargetX, TargetY)
                If (.ID = ElementID.Web) Then
                    MoveThing(Index, TargetX, TargetY)
                    Result = True
                ElseIf (.ID = ElementID.Player) Then
                    Attack(Index, TargetX, TargetY)
                    Result = True
                End If
            End With
            Return Result
        End Function

        Protected Sub ActSpinningGun(ByVal Index As Integer)
            Dim Success As Boolean
            Dim E As Element
            Dim T As Thing = GetFixedThing(Index)

            Success = False
            UpdateAt(T.X, T.Y)
            If (T.P2 >= &H80) Then
                E = Library.GetElementFromID(ElementID.Star)
            Else
                E = Library.GetElementFromID(ElementID.Bullet)
            End If
            If ((T.P2 And &H7F) > Random(9)) Then
                If (T.P1 >= Random(9)) Then
                    If (AbsDiff(T.X, PlayerX) <= 2) Then
                        Success = SpawnProjectile(E, T.X, T.Y, New Vector(0, PosNeg(PlayerY - T.Y)), True)
                    End If
                    If (Not Success) AndAlso (AbsDiff(T.Y, PlayerY) <= 2) Then
                        Success = SpawnProjectile(E, T.X, T.Y, New Vector(PosNeg(PlayerX - T.X), 0), True)
                    End If
                Else
                    Success = SpawnProjectile(E, T.X, T.Y, Rnd, True)
                End If
            End If
        End Sub

        Protected Sub ActStar(ByVal Index As Integer)
            Dim E As Element
            Dim TargetX As Integer
            Dim TargetY As Integer
            Dim T As Thing = GetFixedThing(Index)

            With T
                .P2 = (.P2 - 1) And 255
                If (.P2 > 0) Then
                    If (.P2 Mod 2 = 0) Then
                        .Vector = Seek(.X, .Y)
                        TargetX = .X + .XStep
                        TargetY = .Y + .YStep
                        E = ElementAt(TargetX, TargetY)
                        If (E.ID = ElementID.Player) Or (E.ID = ElementID.Breakable) Then
                            Attack(Index, TargetX, TargetY)
                        Else
                            If (Not E.Floor) Then
                                Push(TargetX, TargetY, .Vector)
                                If (Not Parameters.KoopoBug) Then
                                    Index = CurrentBoard.Things.IndexOf(T)
                                End If
                                T = GetFixedThing(Index)
                            End If
                            If (E.Floor) OrElse (E.ID = ElementID.Water) OrElse (E.ID = ElementID.Lava) Then
                                MoveThing(Index, TargetX, TargetY)
                            End If
                        End If
                    Else
                        UpdateAt(.X, .Y)
                    End If
                Else
                    RemoveThing(Index)
                End If
            End With
        End Sub

        Protected Sub ActStone(ByVal Index As Integer)
            Dim T As Thing = GetFixedThing(Index)
            ColorAt(T.X, T.Y) = (ColorAt(T.X, T.Y) And &H70) + Random(7) + 9
            UpdateAt(T.X, T.Y)
        End Sub

        Protected Sub ActTiger(ByVal Index As Integer)
            Dim E As Element
            Dim Success As Boolean
            Dim T As Thing = GetFixedThing(Index)

            With T
                If (.P2 >= &H80) Then
                    E = Library.GetElementFromID(ElementID.Star)
                Else
                    E = Library.GetElementFromID(ElementID.Bullet)
                End If
                If (.P2 Mod &H80 >= Random(10) * 3) Then
                    If (AbsDiff(.X, PlayerX) <= 2) Then
                        Success = SpawnProjectile(E, .X, .Y, New Vector(0, PosNeg(PlayerY - .Y)), True)
                    End If
                    If (Not Success) AndAlso (AbsDiff(.Y, PlayerY) <= 2) Then
                        Success = SpawnProjectile(E, .X, .Y, New Vector(PosNeg(PlayerX - .X), 0), True)
                    End If
                End If
            End With
            ActLion(Index)
        End Sub

        Protected Sub ActTransporter(ByVal Index As Integer)
            Dim T As Thing = GetFixedThing(Index)
            UpdateAt(T.X, T.Y)
        End Sub

        Protected Sub RemoveItem(ByVal X As Integer, ByVal Y As Integer)
            If (Parameters.PickupToFloor) Then
                RemoveItemFloor(X, Y)
            Else
                ElementAt(X, Y) = Library.GetElementFromID(ElementID.Empty)
            End If
            UpdateAt(X, Y)
        End Sub

        Protected Sub RemoveItemFloor(ByVal X As Integer, ByVal Y As Integer)
            Dim Color As Integer
            Dim Index As Integer
            Dim TargetTile As Tile
            Dim TargetX As Integer
            Dim TargetY As Integer

            For Index = 0 To 3
                TargetX = X + XVectorList4(Index)
                TargetY = Y + YVectorList4(Index)
                TargetTile = TileAt(TargetX, TargetY)
                If (TargetTile.Element.Cycle >= 0) Then
                    With ThingAt(TargetX, TargetY)
                        TargetTile.Element = .UnderElement
                        TargetTile.Color = .UnderColor
                    End With
                End If
                Select Case TargetTile.Element.ID
                    Case ElementID.Empty, ElementID.SliderNS, ElementID.SliderEW, ElementID.Boulder
                        Color = 0
                        Exit For
                    Case ElementID.Floor
                        Color = TargetTile.Color
                End Select
            Next

            If (Color = 0) Then
                ElementAt(X, Y) = Library.GetElementFromID(ElementID.Empty)
            Else
                TileAt(X, Y) = New Tile(Library.GetElementFromID(ElementID.Floor), Color)
            End If
        End Sub

        Protected Sub Interact(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            Dim E As Element = ElementAt(X, Y)

            Select Case E.ID
                Case ElementID.Ammo
                    InteractAmmo(X, Y, Index, XVector, YVector)
                Case ElementID.BoardEdge
                    InteractBoardEdge(X, Y, Index, XVector, YVector)
                Case ElementID.Bomb
                    InteractBomb(X, Y, Index, XVector, YVector)
                Case ElementID.Door
                    InteractDoor(X, Y, Index, XVector, YVector)
                Case ElementID.Energizer
                    InteractEnergizer(X, Y, Index, XVector, YVector)
                Case ElementID.Fake
                    InteractFake(X, Y, Index, XVector, YVector)
                Case ElementID.Forest
                    InteractForest(X, Y, Index, XVector, YVector)
                Case ElementID.Gem
                    InteractGem(X, Y, Index, XVector, YVector)
                Case ElementID.Invisible
                    InteractInvisible(X, Y, Index, XVector, YVector)
                Case ElementID.Key
                    InteractKey(X, Y, Index, XVector, YVector)
                Case ElementID.Lava
                    InteractLava(X, Y, Index, XVector, YVector)
                Case ElementID.Object
                    InteractObject(X, Y, Index, XVector, YVector)
                Case ElementID.Passage
                    InteractPassage(X, Y, Index, XVector, YVector)
                Case ElementID.Scroll
                    InteractScroll(X, Y, Index, XVector, YVector)
                Case ElementID.Slime
                    InteractSlime(X, Y, Index, XVector, YVector)
                Case ElementID.Stone
                    InteractStone(X, Y, Index, XVector, YVector)
                Case ElementID.Torch
                    InteractTorch(X, Y, Index, XVector, YVector)
                Case ElementID.Transporter
                    InteractTransporter(X, Y, Index, XVector, YVector)
                Case ElementID.Water
                    InteractWater(X, Y, Index, XVector, YVector)
                Case ElementID.SliderNS,
                    ElementID.SliderEW,
                    ElementID.Boulder
                    InteractPuzzle(X, Y, Index, XVector, YVector)
                Case ElementID.Bear,
                    ElementID.Bullet,
                    ElementID.DragonPup,
                    ElementID.Head,
                    ElementID.Lion,
                    ElementID.Pairer,
                    ElementID.Roton,
                    ElementID.Ruffian,
                    ElementID.Segment,
                    ElementID.Spider,
                    ElementID.Star,
                    ElementID.Tiger
                    InteractEnemy(X, Y, Index, XVector, YVector)
            End Select
        End Sub

        Protected Sub InteractAmmo(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            World.Ammo += Parameters.AmmoPerPickup
            RemoveItem(X, Y)
            StatusUpdate()
            'playsound(2, ammo)
            If (State.AlertAmmo) Then
                SetMessage(&HC8, Parameters.AmmoMessage.Replace("%1", Parameters.AmmoPerPickup.ToString))
                State.AlertAmmo = False
            End If
            UpdateAt(X, Y)
        End Sub

        Protected Sub InteractBoardEdge(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            Dim TargetX As Integer
            Dim TargetY As Integer
            Dim TargetBoard As Integer
            Dim OldBoard As Integer
            Dim E As Element

            TargetX = X
            TargetY = Y
            If (YVector = -1) Then
                TargetY = Height - 1
                TargetBoard = CurrentBoard.ExitN
            ElseIf (YVector = 1) Then
                TargetY = 0
                TargetBoard = CurrentBoard.ExitS
            ElseIf (XVector = -1) Then
                TargetX = Width - 1
                TargetBoard = CurrentBoard.ExitW
            Else
                TargetX = 0
                TargetBoard = CurrentBoard.ExitE
            End If
            If (TargetBoard > 0) Then
                OldBoard = World.Board
                SetBoard(TargetBoard)
                If (ElementAt(TargetX, TargetY).ID <> ElementID.Player) Then
                    Interact(TargetX, TargetY, Index, State.KeyVectorX, State.KeyVectorY)
                End If
                E = ElementAt(TargetX, TargetY)
                If (E.Floor) OrElse (E.ID = ElementID.Player) Then
                    If (E.ID <> ElementID.Player) Then
                        MoveThing(0, TargetX, TargetY)
                    End If
                    RedrawBoard()
                    XVector = 0
                    YVector = 0
                    EnterBoard()
                    If (Parameters.EnterAlert) Then
                        'ALL:ENTER
                        SendLabel(Player, OOPCodeSet(28) & ":" & OOPCodeSet(74), False, True)
                    End If
                Else
                    SetBoard(OldBoard)
                End If
            End If
        End Sub

        Protected Sub InteractBomb(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            Dim T As Thing

            T = ThingAt(X, Y)
            With T
                If (.P1 > 0) Then
                    Push(X, Y, New Vector(XVector, YVector))
                    If (Not Parameters.KoopoBug) Then
                        Index = CurrentBoard.Things.IndexOf(T)
                    End If
                    T = GetFixedThing(Index)
                Else
                    .P1 = 9
                    UpdateAt(X, Y)
                    SetMessage(&HC8, Parameters.BombActiveMessage)
                    'playsound(4, bomb active)
                End If
            End With
        End Sub

        Protected Sub InteractDoor(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            Dim I As Integer
            Dim Success As Boolean

            I = (ColorAt(X, Y) >> 4) Mod 8
            If (I > 0) Then
                Success = World.Keys(I - 1)
                If (Success) Then
                    World.Keys(I - 1) = False
                End If
            Else
                Success = ((World.Gems And &HFF00) <> 0)
                If (Success) Then
                    World.Gems = (World.Gems And 255)
                End If
            End If
            If (Success) Then
                RemoveItem(X, Y)
                StatusUpdate()
                SetMessage(&HC8, Parameters.DoorOpenMessage.Replace("%1", ColorStrings(I)))
                'playsound(3, door open)
            Else
                SetMessage(&HC8, Parameters.DoorLockedMessage.Replace("%1", ColorStrings(I)))
                'playsound(3, door locked)
            End If
            UpdateAt(X, Y)
        End Sub

        Protected Sub InteractEnemy(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            Attack(Index, X, Y)
        End Sub

        Protected Sub InteractEnergizer(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            'playsound(9, energizer song)
            RemoveItem(X, Y)
            World.EnergyCycles = &H4B
            StatusUpdate()
            If (State.AlertEnergy) Then
                State.AlertEnergy = False
                SetMessage(&HC8, Parameters.EnergizerMessage)
            End If
            'ALL:ENERGIZE
            SendLabel(Player, OOPCodeSet(28) & ":" & OOPCodeSet(73), False, False)
            UpdateAt(X, Y)
        End Sub

        Protected Sub InteractFake(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            If (State.AlertFake) Then
                State.AlertFake = False
                SetMessage(&H96, Parameters.FakeWallMessage)
            End If
        End Sub

        Protected Sub InteractForest(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            Dim ForestSound(1) As Byte

            If (Parameters.ForestToFloor) Then
                TileAt(X, Y) = New Tile(Library.GetElementFromID(ElementID.Floor), &H2)
            Else
                ElementAt(X, Y) = Library.GetElementFromID(ElementID.Empty)
            End If
            ForestSound(0) = Parameters.ForestMusic(State.ForestMusicIndex)
            ForestSound(1) = 2
            State.ForestMusicIndex = (State.ForestMusicIndex + 1) Mod Parameters.ForestMusic.Length
            'playsound(3, forest)
            If (State.AlertForest) Then
                State.AlertForest = False
                SetMessage(&HC8, Parameters.ForestMessage)
            End If
            UpdateAt(X, Y)
        End Sub

        Protected Sub InteractGem(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            World.Gems += 1
            World.Health += Parameters.HealthPerGem
            World.Score += 10
            RemoveItem(X, Y)
            StatusUpdate()
            'playsound(2, gem)
            If (State.AlertGem) Then
                State.AlertGem = False
                SetMessage(&HC8, Parameters.GemMessage)
            End If
            UpdateAt(X, Y)
        End Sub

        Protected Sub InteractInvisible(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            ElementAt(X, Y) = Library.GetElementFromID(ElementID.Normal)
            UpdateAt(X, Y)
            'playsound(3, invisible)
            SetMessage(&H64, Parameters.InvisibleMessage)
        End Sub

        Protected Sub InteractKey(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            Dim I As Integer
            Dim Success As Boolean

            I = ColorAt(X, Y) Mod 8
            If (I > 0) Then
                Success = Not World.Keys(I - 1)
                If (Success) Then
                    World.Keys(I - 1) = True
                End If
            Else
                Success = ((World.Gems And &HFF00) = 0)
                If (Success) Then
                    World.Gems = (World.Gems And 255) Or 256
                End If
            End If
            If (Success) Then
                RemoveItem(X, Y)
                StatusUpdate()
                SetMessage(&HC8, Parameters.KeyMessage.Replace("%1", ColorStrings(I)))
                'playsound(2, get key)
            Else
                SetMessage(&HC8, Parameters.KeyAlreadyMessage.Replace("%1", ColorStrings(I)))
                'playsound(2, already have key)
            End If
            UpdateAt(X, Y)
        End Sub

        Protected Sub InteractLava(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            'playsound(3, water)
            SetMessage(&H64, Parameters.LavaMessage)
        End Sub

        Protected Sub InteractObject(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            'TOUCH
            SendLabel(ThingAt(X, Y), OOPCodeSet(70), False, True)
        End Sub

        Protected Sub InteractPassage(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            ExecutePassage(X, Y)
            XVector = 0
            YVector = 0
            If (Parameters.EnterAlert) Then
                'ALL:ENTER
                SendLabel(Player, OOPCodeSet(28) & ":" & OOPCodeSet(74), False, True)
            End If
        End Sub

        Protected Sub InteractPuzzle(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            Push(X, Y, New Vector(XVector, YVector))
            'playsound(2, puzzle)
        End Sub

        Protected Sub InteractScroll(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            Dim T As Thing
            Dim I As Integer

            'playmusic("c-c+d-d+e-e+f-f+g-g")
            I = ThingIndexAt(X, Y)
            T = CurrentBoard.Things(I)
            T.CurrentInstruction = 0
            ExecuteOOP(I, T.CurrentInstruction, "Scroll")
            If (Scroll.Visible) Then
                State.KeyVectorX = 0
                State.KeyVectorY = 0
            End If
            RemoveThing(ThingIndexAt(X, Y))
            UpdateAt(X, Y)
        End Sub

        Protected Sub InteractSlime(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            Dim I As Integer
            Dim T As Thing = GetFixedThing(Index)

            I = ColorAt(X, Y)
            HarmThing(ThingIndexAt(X, Y))
            TileAt(X, Y) = New Tile(Library.GetElementFromID(ElementID.Breakable), I)
            UpdateAt(X, Y)
            'playsound(2, slimekill)
        End Sub

        Protected Sub InteractStone(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            If (World.Stones < 0) Then
                World.Stones = 0
            End If
            World.Stones += 1
            DestroyAt(X, Y)
            SetMessage(&HC8, Parameters.StoneMessage)
        End Sub

        Protected Sub InteractTorch(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            World.Torches += 1
            RemoveItem(X, Y)
            StatusUpdate()
            If (State.AlertTorch) Then
                SetMessage(&HC8, Parameters.TorchMessage)
                State.AlertTorch = False
            End If
            'playsound(3, torch)
            UpdateAt(X, Y)
        End Sub

        Protected Sub InteractTransporter(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            PushTransporter(X - XVector, Y - YVector, New Vector(XVector, YVector))
            XVector = 0
            YVector = 0
        End Sub

        Protected Sub InteractWater(ByVal X As Integer, ByVal Y As Integer, ByVal Index As Integer, ByRef XVector As Integer, ByRef YVector As Integer)
            'playsound(3, water)
            SetMessage(&H64, Parameters.WaterMessage)
        End Sub

        Protected Function Draw(ByVal X As Integer, ByVal Y As Integer) As AnsiChar
            Dim T As Tile
            Dim Index As Integer

            T = TileAt(X, Y)

            Select Case T.Element.ID
                Case ElementID.Star
                    Index = T.Color + 1
                    If (Index > 15) Then
                        Index = 9
                    End If
                    ColorAt(X, Y) = Index
                    Return RenderedChar(TileAt(X, Y), ThingAt(X, Y), 0)
                Case ElementID.Line, ElementID.Web
                    Return RenderedChar(T, ThingAt(X, Y), AdjacentIDs(X, Y, T.Element.ID))
            End Select

            Return RenderedChar(T, ThingAt(X, Y), 0)
        End Function

        Public Function RenderedChar(ByVal Tile As Tile, ByVal Thing As Thing, ByVal Adjacent As Integer) As AnsiChar
            Dim Index As Integer

            Select Case Tile.Element.ID

                Case ElementID.Empty, ElementID.None
                    Return New AnsiChar(&H20, &HF)

                Case ElementID.BlackText
                    Return New AnsiChar(Tile.Color, &HF)
                Case ElementID.BlueText
                    Return New AnsiChar(Tile.Color, &H1F)
                Case ElementID.BrownText
                    Return New AnsiChar(Tile.Color, &H6F)
                Case ElementID.CyanText
                    Return New AnsiChar(Tile.Color, &H3F)
                Case ElementID.GreenText
                    Return New AnsiChar(Tile.Color, &H2F)
                Case ElementID.RedText
                    Return New AnsiChar(Tile.Color, &H4F)
                Case ElementID.PurpleText
                    Return New AnsiChar(Tile.Color, &H5F)

                Case ElementID.BlinkWall
                    Return New AnsiChar(&HCE, Tile.Color)
                Case ElementID.Bomb
                    With Thing
                        If (.P1 > 1) Then
                            Return New AnsiChar(&H30 + .P1, Tile.Color)
                        Else
                            Return New AnsiChar(&HB, Tile.Color)
                        End If
                    End With
                Case ElementID.Clockwise
                    Select Case ((State.GameTick \ Tile.Element.Cycle) Mod 4)
                        Case 0
                            Return New AnsiChar(&HB3, Tile.Color)
                        Case 1
                            Return New AnsiChar(&H2F, Tile.Color)
                        Case 2
                            Return New AnsiChar(&HC4, Tile.Color)
                        Case Else
                            Return New AnsiChar(&H5C, Tile.Color)
                    End Select
                Case ElementID.Counter
                    Select Case ((State.GameTick \ Tile.Element.Cycle) Mod 4)
                        Case 3
                            Return New AnsiChar(&HB3, Tile.Color)
                        Case 2
                            Return New AnsiChar(&H2F, Tile.Color)
                        Case 1
                            Return New AnsiChar(&HC4, Tile.Color)
                        Case Else
                            Return New AnsiChar(&H5C, Tile.Color)
                    End Select
                Case ElementID.DragonPup
                    Select Case (State.GameTick And 3)
                        Case 0, 2
                            Return New AnsiChar(&H94, Tile.Color)
                        Case 1
                            Return New AnsiChar(&HA2, Tile.Color)
                        Case Else
                            Return New AnsiChar(&H95, Tile.Color)
                    End Select
                Case ElementID.Duplicator
                    With Thing
                        Select Case .P1
                            Case 1
                                Return New AnsiChar(&HFA, Tile.Color)
                            Case 2
                                Return New AnsiChar(&HF9, Tile.Color)
                            Case 3
                                Return New AnsiChar(&HF8, Tile.Color)
                            Case 4
                                Return New AnsiChar(&H6F, Tile.Color)
                            Case 5
                                Return New AnsiChar(&H4F, Tile.Color)
                            Case Else
                                Return New AnsiChar(&HFA, Tile.Color)
                        End Select
                    End With
                Case ElementID.Line
                    Return New AnsiChar(LineChars(Adjacent), Tile.Color)
                Case ElementID.Object
                    Return New AnsiChar(Thing.P1, Tile.Color)
                Case ElementID.Pusher
                    With Thing
                        If (.XStep = 1) Then
                            Return New AnsiChar(&H10, Tile.Color)
                        ElseIf (.XStep = -1) Then
                            Return New AnsiChar(&H11, Tile.Color)
                        ElseIf (.YStep = -1) Then
                            Return New AnsiChar(&H1E, Tile.Color)
                        Else
                            Return New AnsiChar(&H1F, Tile.Color)
                        End If
                    End With
                Case ElementID.SpinningGun
                    Select Case (State.GameTick Mod 8)
                        Case 0, 1
                            Return New AnsiChar(&H18, Tile.Color)
                        Case 2, 3
                            Return New AnsiChar(&H1A, Tile.Color)
                        Case 4, 5
                            Return New AnsiChar(&H19, Tile.Color)
                        Case Else
                            Return New AnsiChar(&H1B, Tile.Color)
                    End Select
                Case ElementID.Star
                    Index = Tile.Color
                    Return New AnsiChar(StarChars(State.GameTick Mod 4), Index)
                Case ElementID.Stone
                    Return New AnsiChar(&H41 + Random(&H1A), Tile.Color)
                Case ElementID.Transporter
                    With Thing
                        If (.XStep = 0) Then
                            Index = ((State.GameTick \ .Cycle) Mod 4) + (.YStep << 1) + 2
                            Return New AnsiChar(TransVChars(Index), Tile.Color)
                        Else
                            Index = ((State.GameTick \ .Cycle) Mod 4) + (.XStep << 1) + 2
                            Return New AnsiChar(TransHChars(Index), Tile.Color)
                        End If
                    End With
                Case ElementID.Web
                    Return New AnsiChar(WebChars(Adjacent), Tile.Color)
            End Select

            'unknown
            If (Tile.Element.DrawCodeEnable) Then
                Return New AnsiChar(&H3F, Tile.Color)
            Else
                Return New AnsiChar(Tile.Element.Char, Tile.Color)
            End If

        End Function

        Protected Sub UpdateAt(ByVal X As Integer, ByVal Y As Integer)
            Dim E As Element = ElementAt(X, Y)
            Dim Ret As AnsiChar

            If (CurrentBoard.IsDark) AndAlso _
                (Not State.EditorMode) AndAlso _
                (Not E.AlwaysShown) AndAlso _
                (Not WithinRadius(PlayerX, PlayerY, X, Y) OrElse (World.TorchCycles <= 0)) Then
                ' dark square
                Ret = New AnsiChar(&HB0, &H7)
            ElseIf (E.DrawCodeEnable) Then
                Ret = Draw(X, Y)
            Else
                Ret = RenderedChar(TileAt(X, Y), ThingAt(X, Y), 0)
            End If

            Video.Plot(X, Y, Ret)
        End Sub

        Protected Sub ExecutePassage(ByVal X As Integer, ByVal Y As Integer)
            Dim Col As Integer
            Dim TargetX As Integer = -1
            Dim TargetY As Integer = -1
            Dim IndexX As Integer
            Dim IndexY As Integer

            Col = ColorAt(X, Y)
            SetBoard(ThingAt(X, Y).P3)

            With CurrentBoard.Things(0)
                For IndexX = 0 To Width - 1
                    For IndexY = 0 To Height - 1
                        With TileAt(IndexX, IndexY)
                            If (.Color = Col) AndAlso (.Element.ID = ElementID.Passage) Then
                                If (Parameters.BuggyPassages) OrElse ((IndexX <> X) OrElse (IndexY <> Y)) Then
                                    TargetX = IndexX
                                    TargetY = IndexY
                                End If
                            End If
                        End With
                    Next
                Next
                If (Parameters.BuggyPassages) Then
                    TileAt(PlayerX, PlayerY) = New Tile(Library.GetElementFromID(ElementID.Empty), 0)
                Else
                    TileAt(PlayerX, PlayerY) = New Tile(CurrentBoard.Things(0).UnderElement, CurrentBoard.Things(0).UnderColor)
                End If
                If (TargetX >= 0) Then
                    .X = TargetX
                    .Y = TargetY
                End If
            End With

            '' OLD METHOD THAT DOES NOT EAT TILES
            'With CurrentBoard.Things(0)
            '    For IndexX = 0 To Width - 1
            '        For IndexY = 0 To Height - 1
            '            If (IndexX = .X) AndAlso (IndexY = .Y) Then
            '                If (.UnderElement.ID = ElementID.Passage) AndAlso (.UnderColor = Col) Then
            '                    TargetX = .X
            '                    TargetY = .Y
            '                End If
            '            Else
            '                With TileAt(IndexX, IndexY)
            '                    If (.Color = Col) AndAlso (.Element.ID = ElementID.Passage) Then
            '                        TargetX = IndexX
            '                        TargetY = IndexY
            '                    End If
            '                End With
            '            End If
            '        Next
            '    Next
            '    If (TargetX >= 0) AndAlso (PlayerX <> TargetX OrElse PlayerY <> TargetY) Then
            '        MoveThing(0, TargetX, TargetY)
            '    End If
            'End With
            State.GamePaused = True
            State.UpdateHUD = True
            'playsound(4, passage)
            RedrawBoard()
            EnterBoard()
        End Sub

        Protected Sub Attack(ByVal Source As Integer, ByVal TargetX As Integer, ByVal TargetY As Integer)
            Dim SourceE As Element
            Dim TargetE As Element
            Dim T As Thing = GetFixedThing(Source)

            With T
                SourceE = ElementAt(.X, .Y)
            End With
            TargetE = ElementAt(TargetX, TargetY)

            If (Source = 0) AndAlso (World.EnergyCycles > 0) Then
                World.Score += TargetE.Score
                StatusUpdate()
            Else
                HarmThing(Source)
            End If

            If (Source > 0) AndAlso (Source <= State.ActIndex) Then
                State.ActIndex -= 1
            End If

            If (TargetE.ID = ElementID.Player) AndAlso (World.EnergyCycles > 0) Then
                World.Score += SourceE.Score
                StatusUpdate()
            Else
                DestroyAt(TargetX, TargetY)
                'PlaySound(2, sndEnemySuicide)
            End If
        End Sub

        Protected Sub MoveThing(ByVal Index As Integer, ByVal TargetX As Integer, ByVal TargetY As Integer)
            Dim SourceX As Integer
            Dim SourceY As Integer
            Dim SourceTile As Tile
            Dim TargetTile As Tile
            Dim GlowX As Integer
            Dim GlowY As Integer
            Dim GlowUpdate As Boolean
            Dim T As Thing = GetFixedThing(Index)

            SourceX = T.X
            SourceY = T.Y
            SourceTile = TileAt(SourceX, SourceY)
            TargetTile = TileAt(TargetX, TargetY)
            ElementAt(SourceX, SourceY) = T.UnderElement
            T.UnderElement = TargetTile.Element
            ElementAt(TargetX, TargetY) = SourceTile.Element
            ColorAt(SourceX, SourceY) = T.UnderColor
            T.UnderColor = TargetTile.Color
            If (SourceTile.Element.ID = ElementID.Player) AndAlso (Parameters.ForcePlayerColor) Then
                ColorAt(TargetX, TargetY) = SourceTile.Color
            ElseIf (TargetTile.Element.ID = ElementID.Empty) Then
                ColorAt(TargetX, TargetY) = SourceTile.Color And &HF
            Else
                ColorAt(TargetX, TargetY) = (TargetTile.Color And &H70) Or (SourceTile.Color And &HF)
            End If
            T.X = TargetX
            T.Y = TargetY
            UpdateAt(SourceX, SourceY)
            UpdateAt(TargetX, TargetY)

            If (Index = 0) AndAlso (CurrentBoard.IsDark) Then
                If ((TargetY - SourceY) ^ 2) + ((TargetX - SourceX) ^ 2) = 1 Then
                    For GlowX = TargetX - 11 To TargetX + 11
                        For GlowY = TargetY - 8 To TargetY + 8
                            If (GlowX >= 0) AndAlso (GlowX < Width) AndAlso (GlowY >= 0) AndAlso (GlowY < Height) Then
                                GlowUpdate = WithinRadius(TargetX, TargetY, GlowX, GlowY)
                                GlowUpdate = GlowUpdate Xor WithinRadius(SourceX, SourceY, GlowX, GlowY)
                                If (GlowUpdate) Then
                                    UpdateAt(GlowX, GlowY)
                                End If
                            End If
                        Next
                    Next
                Else
                    Radius(SourceX, SourceY, RadiusType.Update)
                    Radius(TargetX, TargetY, RadiusType.Update)
                End If
            End If
        End Sub

        Protected Sub Radius(ByVal X As Integer, ByVal Y As Integer, ByVal RadType As RadiusType)
            Dim GlowX As Integer
            Dim GlowY As Integer
            Dim E As Element
            Dim Index As Integer

            For GlowX = X - 7 To X + 7
                For GlowY = Y - 4 To Y + 4
                    If (GlowX >= 0) AndAlso (GlowX < Width) AndAlso (GlowY >= 0) AndAlso (GlowY < Height) Then
                        Select Case RadType
                            Case RadiusType.Explode
                                If WithinRadius(X, Y, GlowX, GlowY) Then
                                    E = ElementAt(GlowX, GlowY)
                                    Index = ThingIndexAt(GlowX, GlowY)
                                    If (E.Code <> "") AndAlso (Index > 0) Then
                                        'BOMBED
                                        SendLabel(CurrentBoard.Things(Index), OOPCodeSet(72), False, True)
                                    End If
                                    If (E.Destructible) OrElse (E.ID = ElementID.Star) Then
                                        DestroyAt(GlowX, GlowY)
                                        E = ElementAt(GlowX, GlowY)
                                    End If
                                    If (E.ID = ElementID.Empty) OrElse (E.ID = ElementID.Breakable) Then
                                        TileAt(GlowX, GlowY) = New Tile(Library.GetElementFromID(ElementID.Breakable), RNG.Next(7) + 9)
                                    End If
                                End If
                            Case RadiusType.Cleanup
                                If WithinRadius(X, Y, GlowX, GlowY) Then
                                    E = ElementAt(GlowX, GlowY)
                                    If E.ID = ElementID.Breakable Then
                                        ElementAt(GlowX, GlowY) = Library.GetElementFromID(ElementID.Empty)
                                    End If
                                End If
                        End Select
                        UpdateAt(GlowX, GlowY)
                    End If
                Next
            Next
        End Sub

        Protected ReadOnly Property AbsDiff(ByVal Val1 As Integer, ByVal Val2 As Integer) As Integer
            Get
                Return Math.Abs(Val1 - Val2)
            End Get
        End Property

        Protected Sub HarmThing(ByVal Index As Integer)
            Dim E As Element
            Dim Color As Integer
            Dim T As Thing = GetFixedThing(Index)

            If (Index = 0) Then
                If (World.Health > 0) Then
                    World.Health -= 10
                    StatusUpdate()
                    SetMessage(&H64, Parameters.OuchMessage)
                    Color = ColorAt(T.X, T.Y)
                    ColorAt(T.X, T.Y) = (Library.GetElementFromID(ElementID.Player).Color And &HF) Or &H70
                    UpdateAt(T.X, T.Y)
                    ColorAt(T.X, T.Y) = Color
                    If (World.Health > 0) Then
                        World.TimePassed = 0
                        State.TimeLimitTicks = CurrentBoard.TimeLimit * 100
                        If (CurrentBoard.RestartZap) Then
                            'playsound(4, time up)
                            With CurrentBoard
                                MoveThing(0, .EnterX, .EnterY)
                            End With
                            State.GamePaused = True
                            State.UpdateHUD = True
                        End If
                        'playsound(4, ouch)
                    Else
                        'playsound(5, game over)
                    End If
                End If
            Else
                E = ElementAt(T.X, T.Y)
                Select Case E.ID
                    Case ElementID.Bullet
                        'playsound(3, bullet death)
                    Case ElementID.Object
                    Case Else
                        'playsound(3, enemy death)
                End Select
                RemoveThing(Index)
            End If
        End Sub

        Protected Sub DestroyAt(ByVal X As Integer, ByVal Y As Integer)
            Dim Index As Integer = ThingIndexAt(X, Y)
            If (Index = -1) Then
                RemoveItem(X, Y)
            Else
                HarmThing(Index)
            End If
        End Sub

        Protected Sub RemoveThing(ByVal ThingIndex As Integer)
            Dim I As Integer
            Dim Thing As Thing = GetFixedThing(ThingIndex)

            If (ThingIndex > 0) AndAlso (ThingIndex < CurrentBoard.Things.Count) Then
                With Thing
                    .Code = Nothing
                    If (ThingIndex < State.ActIndex) Then
                        State.ActIndex -= 1
                    End If
                    TileAt(.X, .Y) = New Tile(.UnderElement, .UnderColor)
                    If (.Y >= 0) Then
                        UpdateAt(.X, .Y)
                    End If
                End With
                For I = 0 To CurrentBoard.Things.Count - 1
                    With CurrentBoard.Things(I)
                        If (.Follower > ThingIndex) Then
                            .Follower -= 1
                        ElseIf (.Follower = ThingIndex) Then
                            .Follower = -1
                        End If
                        If (.Leader > ThingIndex) Then
                            .Leader -= 1
                        ElseIf (.Leader = ThingIndex) Then
                            .Leader = -1
                        End If
                    End With
                Next
                CurrentBoard.Things.RemoveAt(ThingIndex)
            End If
        End Sub

        Protected Function SpawnProjectile(ByVal ProjElement As Element, ByVal X As Integer, ByVal Y As Integer, ByVal Direction As Vector, ByVal EnemyOwned As Boolean) As Boolean
            Dim E As Element
            Dim TargetX As Integer
            Dim TargetY As Integer
            Dim Success As Boolean

            TargetX = X + Direction.X
            TargetY = Y + Direction.Y
            E = ElementAt(TargetX, TargetY)
            If (E.Floor) OrElse (E.ID = ElementID.Water) OrElse (E.ID = ElementID.Lava) Then
                SpawnThing(TargetX, TargetY, ProjElement, ProjElement.Color, ProjElement.Cycle, Nothing)
                With CurrentBoard.Things(ThingCount - 1)
                    If (EnemyOwned) Then
                        .P1 = 1
                    Else
                        .P1 = 0
                    End If
                    .XStep = Direction.X
                    .YStep = Direction.Y
                    .P2 = &H64
                    Success = True
                End With
            ElseIf (E.ID = ElementID.Breakable) OrElse (E.Destructible AndAlso ((E.ID = ElementID.Player AndAlso World.EnergyCycles = 0) OrElse (EnemyOwned = False))) Then
                DestroyAt(TargetX, TargetY)
                'playsound(2, bullet die)
                Success = True
            Else
                Success = False
            End If
            Return Success
        End Function

        Protected Sub SpawnThing(ByVal X As Integer, ByVal Y As Integer, ByVal E As Element, ByVal Col As Integer, ByVal Cycle As Integer, ByVal Source As Thing)
            Dim T As Thing
            If (ThingCount < Parameters.MaxThings) Then
                T = New Thing
                If (Not (Source Is Nothing)) Then
                    T.XStep = Source.XStep
                    T.YStep = Source.YStep
                    T.P1 = Source.P1
                    T.P2 = Source.P2
                    T.P3 = Source.P3
                    T.Follower = Source.Follower
                    T.Leader = Source.Leader
                    If (Source.Code Is Nothing) Then
                        T.Code = Nothing
                    Else
                        T.Code = New CodeContainer(Source.Code.Code)
                        T.Length = T.Code.Code.Length
                    End If
                End If
                With T
                    T.X = X
                    T.Y = Y
                    T.Cycle = Cycle
                    T.CurrentInstruction = 0
                    With TileAt(X, Y)
                        T.UnderElement = .Element
                        T.UnderColor = .Color
                    End With
                End With
                CurrentBoard.Things.Add(T)
                If (ElementAt(X, Y).EditorFloor) Then
                    ColorAt(X, Y) = (ColorAt(X, Y) And &H70) + (Col And &HF)
                Else
                    ColorAt(X, Y) = Col
                End If
                ElementAt(X, Y) = E
                UpdateAt(X, Y)
            End If
        End Sub

        Protected Sub Push(ByVal X As Integer, ByVal Y As Integer, ByVal V As Vector)
            Dim TargetX As Integer = X + V.X
            Dim TargetY As Integer = Y + V.Y
            Dim E As Element

            E = ElementAt(X, Y)
            If (E.Pushable) OrElse
                ((V.X = 0) AndAlso (E.ID = ElementID.SliderNS)) OrElse
                ((V.Y = 0) AndAlso (E.ID = ElementID.SliderEW)) Then
                E = ElementAt(TargetX, TargetY)
                If (E.ID = ElementID.Transporter) Then
                    PushTransporter(X, Y, V)
                ElseIf (E.ID <> ElementID.Empty) Then
                    Push(TargetX, TargetY, V)
                End If
                E = ElementAt(TargetX, TargetY)
                If (Not E.Floor) Then
                    If (E.Destructible) AndAlso (E.ID <> ElementID.Player) Then
                        DestroyAt(TargetX, TargetY)
                        E = ElementAt(TargetX, TargetY)
                    End If
                End If
                If (E.Floor) Then
                    Move(X, Y, TargetX, TargetY)
                End If
            End If
        End Sub

        Protected Sub PushTransporter(ByVal X As Integer, ByVal Y As Integer, ByVal V As Vector)
            Dim TargetX As Integer = X + V.X
            Dim TargetY As Integer = Y + V.Y
            Dim SearchX As Integer
            Dim SearchY As Integer
            Dim DestX As Integer
            Dim DestY As Integer
            Dim TransEnd As Boolean
            Dim Found As Boolean

            Dim T As Thing
            Dim TargetTile As Tile

            T = ThingAt(TargetX, TargetY)
            If (T.XStep = V.X) AndAlso (T.YStep = V.Y) Then
                SearchX = T.X
                SearchY = T.Y
                DestX = -1
                TransEnd = False
                Found = True
                Do
                    SearchX += V.X
                    SearchY += V.Y
                    TargetTile = TileAt(SearchX, SearchY)
                    If (TargetTile.Element.ID = ElementID.BoardEdge) Then
                        TransEnd = True
                    Else
                        If (Found) Then
                            Found = False
                            If (Not TargetTile.Element.Floor) Then
                                Push(SearchX, SearchY, V)
                                TargetTile = TileAt(SearchX, SearchY)
                            End If
                            If (TargetTile.Element.Floor) Then
                                TransEnd = True
                                DestX = SearchX
                                DestY = SearchY
                            Else
                                DestX = -1
                            End If
                        End If
                    End If
                    If (TargetTile.Element.ID = ElementID.Transporter) Then
                        With ThingAt(SearchX, SearchY)
                            If (.XStep = -V.X) AndAlso (.YStep = -V.Y) Then
                                Found = True
                            End If
                        End With
                    End If
                Loop Until (TransEnd)
                If (DestX <> -1) Then
                    Move(T.X - T.XStep, T.Y - T.YStep, DestX, DestY)
                    'playsound(sndtransporter)
                End If
            End If
        End Sub

        Protected Sub Move(ByVal X As Integer, ByVal Y As Integer, ByVal TargetX As Integer, ByVal TargetY As Integer)
            Dim Index As Integer
            Dim T As Tile

            Index = ThingIndexAt(X, Y)
            If (Index < 0) Then
                T = TileAt(X, Y)
                TileAt(TargetX, TargetY) = T
                UpdateAt(TargetX, TargetY)
                RemoveItem(X, Y)
                UpdateAt(X, Y)
            Else
                MoveThing(Index, TargetX, TargetY)
            End If
        End Sub

        Protected Sub MoveRiver(ByVal Index As Integer)
            Dim XVector As Integer = 0
            Dim YVector As Integer = 0
            Dim TargetX As Integer
            Dim TargetY As Integer
            Dim Thing As Thing = GetFixedThing(Index)

            With Thing
                Select Case .UnderElement.ID
                    Case ElementID.WaterN
                        YVector = -1
                    Case ElementID.WaterS
                        YVector = 1
                    Case ElementID.WaterW
                        XVector = -1
                    Case ElementID.WaterE
                        XVector = 1
                End Select
                If (XVector <> 0) OrElse (YVector <> 0) Then
                    TargetX = .X + XVector
                    TargetY = .Y + YVector
                    If (Index = 0) Then
                        Interact(TargetX, TargetY, 0, XVector, YVector)
                    End If
                    If (ElementAt(TargetX, TargetY).Floor) Then
                        MoveThing(Index, TargetX, TargetY)
                    End If
                End If
            End With
        End Sub

        Protected Sub InitBoard(ByVal BoardNumber As Integer)
            If (BoardNumber >= Boards.Count) Then
                BoardNumber = World.Board
            End If
            World.Board = BoardNumber
        End Sub

        Public Sub SetBoard(ByVal BoardNumber As Integer)
            Messenger.Clear()
            ElementAt(PlayerX, PlayerY) = Library.GetElementFromID(ElementID.Player)
            ColorAt(PlayerX, PlayerY) = ElementAt(PlayerX, PlayerY).Color
            InitBoard(BoardNumber)
            'State.ActIndex = 0
        End Sub

        Public Sub SetBoardEditor(ByVal BoardNumber As Integer)
            World.Board = BoardNumber
            RedrawBoard()
        End Sub

        Protected Sub RedrawBoard()
            Dim X As Integer
            Dim Y As Integer
            For Y = 0 To Height - 1
                For X = 0 To Width - 1
                    UpdateAt(X, Y)
                Next
            Next
        End Sub

        Protected Sub UpdateBorder()
            Dim X As Integer
            For X = 0 To Width - 1
                UpdateAt(X, 0)
                UpdateAt(X, Height - 1)
            Next
            For X = 1 To Height - 2
                UpdateAt(0, X)
                UpdateAt(Width - 1, X)
            Next
        End Sub

        Protected Sub BoardFade()
            'todo: fade to purple
            RedrawBoard()
        End Sub

        Protected Sub EnterBoard()
            With CurrentBoard
                .EnterX = PlayerX
                .EnterY = PlayerY
                If (.IsDark) AndAlso (State.AlertDark) Then
                    SetMessage(&HC8, Parameters.DarkMessage)
                    State.AlertDark = False
                End If
                State.TimeLimitTicks = .TimeLimit * 100
            End With
            World.TimePassed = 0
            StatusUpdate()
        End Sub

        Protected Sub SetMessage(ByVal Ticks As Integer, ByVal Message As String)
            Ticks \= ((State.GameWaitTime) + 1)
            If (Messenger.TicksLeft > 0) Then
                UpdateBorder()
            End If
            Messenger.SetMessage(Ticks, Message)
        End Sub

        Protected Sub PlaySound(ByVal Priority As Integer, ByVal Sound() As Byte)

        End Sub

        Protected Sub ConveyorMove(ByVal X As Integer, ByVal Y As Integer, ByVal RotationDirection As Integer)
            Dim FullyPushable As Boolean
            Dim Index As Integer
            Dim RotationIndex As Integer
            Dim RotationStart As Integer
            Dim RotationEnd As Integer
            Dim TempThing As Integer
            Dim TempThingX As Integer
            Dim TempThingY As Integer
            Dim TempTile As Tile = Nothing
            Dim SourceX As Integer
            Dim SourceY As Integer
            Dim TargetX As Integer
            Dim TargetY As Integer
            If RotationDirection >= 0 Then
                RotationStart = 7
                RotationEnd = 0
            Else
                RotationStart = 0
                RotationEnd = 7
            End If
            FullyPushable = True
            For Index = 0 To 7
                If Not ElementAt(X + XVectorList8(Index), Y + YVectorList8(Index)).Pushable Then
                    FullyPushable = False
                    Exit For
                End If
            Next
            If FullyPushable Then
                SourceX = X + XVectorList8(RotationStart)
                SourceY = Y + YVectorList8(RotationStart)
                TempThing = ThingIndexAt(SourceX, SourceY)
                TempThingX = SourceX
                TempThingY = SourceY
                If TempThing >= 0 Then
                    With CurrentBoard.Things(TempThing)
                        .X = 0
                        .Y = 0
                    End With
                End If
                TempTile = TileAt(TempThingX, TempThingY)
                TileAt(TempThingX, TempThingY) = New Tile(Library.GetElementFromID(ElementID.Empty), 0)
            End If
            For RotationIndex = RotationStart To RotationEnd Step -RotationDirection
                SourceX = X + XVectorList8(RotationIndex And 7)
                SourceY = Y + YVectorList8(RotationIndex And 7)
                TargetX = X + XVectorList8((RotationIndex + RotationDirection) And 7)
                TargetY = Y + YVectorList8((RotationIndex + RotationDirection) And 7)
                If ElementAt(SourceX, SourceY).Pushable Then
                    If ElementAt(TargetX, TargetY).ID = ElementID.Empty Then
                        Move(SourceX, SourceY, TargetX, TargetY)
                    End If
                End If
            Next
            If FullyPushable Then
                TargetX = X + XVectorList8((RotationStart + RotationDirection) And 7)
                TargetY = Y + YVectorList8((RotationStart + RotationDirection) And 7)
                If TempThing >= 0 Then
                    With CurrentBoard.Things(TempThing)
                        .X = TargetX
                        .Y = TargetY
                    End With
                End If
                TileAt(TargetX, TargetY) = TempTile
            End If
            For Index = 0 To 7
                UpdateAt(X + XVectorList8(Index), Y + YVectorList8(Index))
            Next
        End Sub

        Protected Function EraseTile(ByVal X As Integer, ByVal Y As Integer) As Boolean
            Dim Index As Integer
            Index = ThingIndexAt(X, Y)
            With ElementAt(X, Y)
                If (.ID = ElementID.Empty) OrElse (Index = 0) Then
                    Return False
                ElseIf (Index > 0) Then
                    RemoveThing(Index)
                ElseIf (Not .EditorFloor) Then
                    ElementAt(X, Y) = Library.GetElementFromID(ElementID.Empty)
                End If
                Return True
            End With
        End Function

        Protected Sub PlotTile(ByVal X As Integer, ByVal Y As Integer, ByVal T As Tile)
            Dim Color As Integer

            If (ElementAt(X, Y).ID <> ElementID.Player) Then
                Color = T.Color
                If (T.Element.Color >= &HF0) Then
                    If (Color = 0) Then
                        Color = ColorAt(X, Y)
                    End If
                    If (Color = 0) Then
                        Color = &HF
                    End If
                    If (T.Element.Color = &HFE) Then
                        Color = ((Color - 8) << 4) + &HF
                    End If
                Else
                    Color = T.Element.Color
                End If
                If (ElementAt(X, Y).ID = T.Element.ID) Then
                    ColorAt(X, Y) = Color
                Else
                    DestroyAt(X, Y)
                    If (T.Element.Cycle < 0) Then
                        TileAt(X, Y) = New Tile(T.Element, Color)
                    Else
                        SpawnThing(X, Y, T.Element, Color, T.Element.Cycle, Nothing)
                    End If
                End If
                UpdateAt(X, Y)
            End If
        End Sub

        Public ReadOnly Property PlayerX() As Integer
            Get
                Return CurrentBoard.Things(0).X
            End Get
        End Property

        Public ReadOnly Property PlayerY() As Integer
            Get
                Return CurrentBoard.Things(0).Y
            End Get
        End Property

        Public ReadOnly Property Player As Thing
            Get
                Return CurrentBoard.Things(0)
            End Get
        End Property

        Protected ReadOnly Property ThingCount As Integer
            Get
                Return CurrentBoard.Things.Count
            End Get
        End Property

        Public Sub SetEditorMode(ByVal Enabled As Boolean)
            If (Enabled) Then
                With Library.GetElementFromID(ElementID.Invisible)
                    .Char = 176
                    .Color = 255
                End With
                State.PlayerElement = Library.GetElementFromID(ElementID.Player)
            Else
                With Library.GetElementFromID(ElementID.Invisible)
                    .Char = 32
                    .Color = 255
                End With
            End If
            State.EditorMode = Enabled
        End Sub

        Protected Property TileAt(ByVal X As Integer, ByVal Y As Integer) As Tile
            Get
                Return CurrentBoard.TileAt(X, Y)
            End Get
            Set(ByVal value As Tile)
                CurrentBoard.TileAt(X, Y) = value
            End Set
        End Property

        Protected Property ColorAt(ByVal X As Integer, ByVal Y As Integer) As Integer
            Get
                Return CurrentBoard.ColorAt(X, Y)
            End Get
            Set(ByVal value As Integer)
                CurrentBoard.ColorAt(X, Y) = value
            End Set
        End Property

        Protected Property ElementAt(ByVal X As Integer, ByVal Y As Integer) As Element
            Get
                Return CurrentBoard.ElementAt(X, Y)
            End Get
            Set(ByVal value As Element)
                CurrentBoard.ElementAt(X, Y) = value
            End Set
        End Property

        Protected ReadOnly Property ThingIndexAt(ByVal X As Integer, ByVal Y As Integer) As Integer
            Get
                Return CurrentBoard.ThingIndexAt(X, Y)
            End Get
        End Property

        Protected ReadOnly Property ThingAt(ByVal X As Integer, ByVal Y As Integer) As Thing
            Get
                Return CurrentBoard.ThingAt(X, Y)
            End Get
        End Property

        Protected ReadOnly Property Width As Integer
            Get
                Return CurrentBoard.Width
            End Get
        End Property

        Protected ReadOnly Property Height As Integer
            Get
                Return CurrentBoard.Height
            End Get
        End Property

        Protected ReadOnly Property WithinRadius(ByVal CenterX As Integer, ByVal CenterY As Integer, ByVal X As Integer, ByVal Y As Integer) As Boolean
            Get
                Dim XR As Integer = (CenterX - X)
                Dim YR As Integer = (CenterY - Y)
                Return ((XR * XR) + ((YR * YR) * 2) < 50)
            End Get
        End Property

        Protected Function Random(ByVal Range As Integer) As Integer
            Return RNG.Next(Range)
        End Function

        Protected ReadOnly Property AdjacentIDs(ByVal X As Integer, ByVal Y As Integer, ByVal ID As ElementID) As Integer
            Get
                Return CurrentBoard.AdjacentIDs(X, Y, ID)
            End Get
        End Property

    End Class

End Namespace