﻿Namespace Roton

    Public Enum EnvironmentGameType As Integer
        None = 0
        ZZT = 1
        SuperZZT = 2
    End Enum

    Public Class EnvironmentParameters
        Public AmmoPerPickup As Integer
        Public AmmoMessage As String
        Public BoardHeight As Integer
        Public BoardWidth As Integer
        Public BombActiveMessage As String
        Public BuggyPassages As Boolean
        Public CantShootMessage As String
        Public DarkMessage As String
        Public DeathColorMatch As Boolean
        Public DisplayWide As Boolean
        Public DoorLockedMessage As String
        Public DoorOpenMessage As String
        Public EnergizerMessage As String
        Public EnterAlert As Boolean
        Public FakeWallMessage As String
        Public ForcePlayerColor As Boolean
        Public ForestMessage As String
        Public ForestMusic As Byte()
        Public ForestToFloor As Boolean
        Public GameOverMessage As String
        Public GemMessage As String
        Public HealthPerGem As Integer
        Public HintsEnabled As Boolean
        Public InvisibleMessage As String
        Public KeyMessage As String
        Public KeyAlreadyMessage As String
        Public KoopoBug As Boolean
        Public LavaMessage As String
        Public MaxFlags As Integer
        Public MaxBoards As Integer
        Public MaxThings As Integer
        Public MessageLines As Integer
        Public MultiMovement As Boolean
        Public NoAmmoMessage As String
        Public NotDarkMessage As String
        Public NoTimeMessage As String
        Public NoTorchesMessage As String
        Public OuchMessage As String
        Public PickupToFloor As Boolean
        Public PreKillObject As Boolean
        Public PressEnterMessage As String
        Public RiverEnabled As Boolean
        Public ScrollHeight As Integer
        Public ScrollWidth As Integer
        Public StoneMessage As String
        Public StonesEnabled As Boolean
        Public TorchesEnabled As Boolean
        Public TorchMessage As String
        Public ViewHeight As Integer
        Public ViewWidth As Integer
        Public WaterMessage As String

        Public Shared Function ZZT() As EnvironmentParameters
            Dim Ret As New EnvironmentParameters
            With Ret
                .AmmoPerPickup = 5
                .BoardHeight = 25
                .BoardWidth = 60
                .BuggyPassages = True
                .DeathColorMatch = True
                .DisplayWide = False
                .EnterAlert = False
                .ForcePlayerColor = True
                .ForestMusic = {&H39}
                .ForestToFloor = False
                .HealthPerGem = 1
                .HintsEnabled = False
                .KoopoBug = True
                .MaxBoards = 101
                .MaxFlags = 10
                .MaxThings = 151
                .MessageLines = 1
                .MultiMovement = False
                .PickupToFloor = False
                .PreKillObject = True
                .RiverEnabled = False
                .ScrollHeight = 19
                .ScrollWidth = 49
                .StonesEnabled = False
                .TorchesEnabled = True
                .ViewHeight = 25
                .ViewWidth = 60

                .AmmoMessage = "Ammunition - %1 shots per container."
                .BombActiveMessage = "Bomb activated!"
                .CantShootMessage = "Can't shoot in this place!"
                .DarkMessage = "Room is dark - you need to light a torch!"
                .DoorLockedMessage = "The %1 door is locked!"
                .DoorOpenMessage = "The %1 door is now open."
                .EnergizerMessage = "Energizer - You are invincible"
                .FakeWallMessage = "A fake wall - secret passage!"
                .ForestMessage = "A path is cleared through the forest."
                .GameOverMessage = "Game over  -  Press ESCAPE"
                .GemMessage = "Gems give you health!"
                .InvisibleMessage = "You are blocked by an invisible wall."
                .KeyMessage = "You now have the %1 key."
                .KeyAlreadyMessage = "You already have a %1 key!"
                .NoAmmoMessage = "You don't have any ammo!"
                .NotDarkMessage = "Don't need torch - room is not dark!"
                .NoTimeMessage = "Running out of time!"
                .NoTorchesMessage = "You don't have any torches!"
                .OuchMessage = "Ouch!"
                .PressEnterMessage = "Press ENTER to select this"
                .TorchMessage = "Torch - used for lighting in the underground."
                .WaterMessage = "Your way is blocked by water."
            End With
            Return Ret
        End Function

        Public Shared Function SuperZZT() As EnvironmentParameters
            Dim Ret As New EnvironmentParameters
            With Ret
                .AmmoPerPickup = 20
                .BoardHeight = 80
                .BoardWidth = 96
                .BuggyPassages = False
                .DeathColorMatch = False
                .DisplayWide = True
                .EnterAlert = True
                .ForcePlayerColor = False
                .ForestMusic = {&H45, &H40, &H47, &H50, &H46, &H41, &H48, &H51}
                .ForestToFloor = True
                .HealthPerGem = 10
                .HintsEnabled = True
                .KoopoBug = True
                .MaxBoards = 33
                .MaxFlags = 16
                .MaxThings = 129
                .MessageLines = 2
                .MultiMovement = True
                .PickupToFloor = True
                .PreKillObject = False
                .RiverEnabled = True
                .ScrollHeight = 23
                .ScrollWidth = 37
                .StonesEnabled = True
                .TorchesEnabled = False
                .ViewHeight = 25
                .ViewWidth = 37

                .AmmoMessage = "Ammunition:" & Chr(13) & "%1 shots"
                .BombActiveMessage = "Bomb activated!"
                .CantShootMessage = "Can't shoot" & Chr(13) & "in this place!"
                .DoorLockedMessage = "The %1 door" & Chr(13) & "is locked!"
                .DoorOpenMessage = "The %1 door" & Chr(13) & "is now open."
                .EnergizerMessage = "Shield:" & Chr(13) & "You are invincible"
                .FakeWallMessage = "A fake wall:" & Chr(13) & "Secret Passage!"
                .ForestMessage = "A path is cleared" & Chr(13) & "through the forest."
                .GameOverMessage = "Game over" & Chr(13) & "-- Press ESCAPE --"
                .GemMessage = "Gems give you health!"
                .InvisibleMessage = "You are blocked" & Chr(13) & "by an invisible wall."
                .KeyMessage = "You now have the" & Chr(13) & "%1 key."
                .KeyAlreadyMessage = "You already have a" & Chr(13) & "%1 key!"
                .LavaMessage = "Your way is" & Chr(13) & "blocked by lava."
                .NoAmmoMessage = "You don't have" & Chr(13) & "any ammo!"
                .NoTimeMessage = "Running out of time!"
                .OuchMessage = "Ouch!"
                .PressEnterMessage = "Press ENTER to select this"
                .StoneMessage = "You have found a" & Chr(13) & "Stone of Power!"
            End With
            Return Ret
        End Function
    End Class

    Public Class EnvironmentGameState
        Public AlertAmmo As Boolean = True
        Public AlertNoAmmo As Boolean = True
        Public AlertNoShoot As Boolean = True
        Public AlertTorch As Boolean = True
        Public AlertNoTorch As Boolean = True
        Public AlertNotDark As Boolean = True
        Public AlertDark As Boolean = True
        Public AlertForest As Boolean = True
        Public AlertFake As Boolean = True
        Public AlertGem As Boolean = True
        Public AlertEnergy As Boolean = True
        Public QuitZZT As Boolean = False
        Public BreakGameLoop As Boolean = False
        Public PlayerElement As Element
        Public StartBoard As Integer = 0
        Public GameSpeed As Integer = 4
        Public GameWaitTime As Integer = 0
        Public GameTick As Integer = 0
        Public ActIndex As Integer = 0
        Public GamePaused As Boolean = False
        Public EditorMode As Boolean = False
        Public WorldLoaded As Boolean = False
        Public KeyVectorX As Integer = 0
        Public KeyVectorY As Integer = 0
        Public LastKeyVectorX As Integer = 0
        Public LastKeyVectorY As Integer = 0
        Public KeyShift As Boolean = False
        Public KeyPressed As Byte = 0
        Public KeyArrow As Boolean = False
        Public GameQuiet As Boolean = False
        Public DisableSound As Boolean = False
        Public SoundTicks As Integer = 0
        Public SoundPlaying As Boolean = False
        Public TitleScreen As Boolean = False
        Public GamePausedBlink As Boolean = False
        Public MainTimer As Integer = 0
        Public TimeLimitTicks As Integer = 0
        Public Execution As EnvironmentGameExecutionState
        Public UpdateHUD As Boolean
        Public RedrawHUD As Boolean
        Public ForestMusicIndex As Integer
    End Class

    Public Enum EnvironmentGameExecutionState As Integer
        Init = 0
        TitleScreenInit
        TitleScreenPreLoop
        TitleScreen
        GameInit
        Game
        Quit
    End Enum

    Public Class Environment
        Public State As New EnvironmentGameState
        Public Parameters As New EnvironmentParameters

        Public Library As Library
        Public World As World
        Public Boards As New List(Of Board)
        Private _Audio As Audio
        Private _Video As Video
        Public Input As Input
        Public Scroll As Scroll
        Public ScrollOwner As Thing
        Public Messenger As Messenger
        Public [Type] As EnvironmentGameType

        Protected RNG As Random
        Protected _RNGSeed As Integer
        Public Property RNGSeed As Integer
            Get
                Return _RNGSeed
            End Get
            Set(ByVal value As Integer)
                _RNGSeed = value
                RNG = New Random(value)
            End Set
        End Property

        Public Sub New()
            _Audio = New AudioNull
            _Video = New VideoNull
            Input = New InputNull
            Scroll = New ScrollNull
            Messenger = New MessengerNull
            State = New EnvironmentGameState
            RNGSeed = CInt(Now.Ticks And &H7FFFFFFF)
        End Sub

        Public Property Audio As Audio
            Get
                Return _Audio
            End Get
            Set(ByVal value As Audio)
                _Audio = value
            End Set
        End Property

        Public Property Video As Video
            Get
                Return _Video
            End Get
            Set(ByVal value As Video)
                _Video = value
                _Video.SetSize(Width, Height)
                _Video.Write(0, 0, "Video initialized", &H8F)
            End Set
        End Property

        Public ReadOnly Property CurrentBoard As Board
            Get
                Return Boards(World.Board)
            End Get
        End Property

        Public Sub EditorUpdate(ByVal X As Integer, ByVal Y As Integer)
            UpdateAt(X, Y)
        End Sub

        Public ReadOnly Property EditorChar(ByVal C As Integer, ByVal E As Element) As AnsiChar
            Get
                Dim Ret As AnsiChar

                Ret.Char = E.Char
                If (E.Color < &HF0) Then
                    Ret.Color = E.Color
                ElseIf (E.Color = &HFE) Then
                    Ret.Color = ((C And &H7) << 4) Or &HF
                Else
                    Ret.Color = C
                End If
                Return Ret
            End Get
        End Property

        Public Sub EditorMove(ByVal SourceX As Integer, ByVal SourceY As Integer, ByVal TargetX As Integer, ByVal TargetY As Integer)
            Move(SourceX, SourceY, TargetX, TargetY)
        End Sub

        Public Sub EditorMovePlayer(ByVal TargetX As Integer, ByVal TargetY As Integer)
            MoveThing(0, TargetX, TargetY)
        End Sub

        Public Function EditorIndexAt(ByVal X As Integer, ByVal Y As Integer) As Integer
            Return ThingIndexAt(X, Y)
        End Function

        Public Sub EditorPlot(ByVal X As Integer, ByVal Y As Integer, ByVal T As Tile, ByVal Th As Thing, ByVal Stats As Boolean)
            Dim I As Integer
            I = ThingIndexAt(X, Y)
            If (I <> 0) Then
                If (I > 0) Then
                    RemoveThing(I)
                End If
                If (Not Stats) Then
                    TileAt(X, Y) = T
                Else
                    If Not (ElementAt(X, Y).EditorFloor) Then
                        ElementAt(X, Y) = Library.GetElementFromID(ElementID.Empty)
                    End If
                    If (Th Is Nothing) Then
                        SpawnThing(X, Y, T.Element, T.Color, T.Element.Cycle, Th)
                    Else
                        SpawnThing(X, Y, T.Element, T.Color, Th.Cycle, Th)
                    End If
                End If
            End If
            UpdateAt(X, Y)
            UpdateAt(X - 1, Y)
            UpdateAt(X + 1, Y)
            UpdateAt(X, Y + 1)
            UpdateAt(X, Y - 1)
        End Sub

        Public Sub EditorRemoveBoard(ByVal Index As Integer)
            Dim BoardIndex As Integer
            Dim ThingIndex As Integer

            For BoardIndex = 0 To Boards.Count - 1
                With Boards(BoardIndex)
                    If (.ExitN > Index) Then
                        .ExitN -= 1
                    ElseIf (.ExitN = Index) Then
                        .ExitN = 0
                    End If
                    If (.ExitS > Index) Then
                        .ExitS -= 1
                    ElseIf (.ExitS = Index) Then
                        .ExitS = 0
                    End If
                    If (.ExitW > Index) Then
                        .ExitW -= 1
                    ElseIf (.ExitW = Index) Then
                        .ExitW = 0
                    End If
                    If (.ExitE > Index) Then
                        .ExitE -= 1
                    ElseIf (.ExitE = Index) Then
                        .ExitE = 0
                    End If
                    For ThingIndex = 0 To .Things.Count - 1
                        If (.TileAt(.Things(ThingIndex).X, .Things(ThingIndex).Y).Element.ID = ElementID.Passage) Then
                            With .ThingAt(.Things(ThingIndex).X, .Things(ThingIndex).Y)
                                If (.P3 > Index) Then
                                    .P3 -= 1
                                ElseIf (.P3 = Index) Then
                                    .P3 = 0
                                End If
                            End With
                        End If
                    Next
                End With
            Next
            Boards.RemoveAt(Index)
        End Sub
    End Class

End Namespace