﻿Namespace Roton
    Public Class CodeContainer
        Public Code As String
        Public Sub New(ByVal NewCode As String)
            Code = NewCode
        End Sub
    End Class

    Public Class Thing
        Public X As Integer = -1
        Public Y As Integer = -1
        Public XStep As Integer = 0
        Public YStep As Integer = 0
        Public Cycle As Integer = 0
        Public P1 As Integer = 0
        Public P2 As Integer = 0
        Public P3 As Integer = 0
        Public Follower As Integer = -1
        Public Leader As Integer = -1
        Public UnderElement As Element = Nothing
        Public UnderColor As Integer = 0
        Public Code As CodeContainer = Nothing
        Public CurrentInstruction As Integer = -1
        Public Length As Integer = 0

        Public Sub New()
        End Sub

        Public Sub New(ByVal SourceThing As Thing)
            MyBase.New()
            If (SourceThing Is Nothing) Then
                Exit Sub
            End If
            With SourceThing
                XStep = .XStep
                YStep = .YStep
                Cycle = .Cycle
                P1 = .P1
                P2 = .P2
                P3 = .P3
                Follower = .Follower
                Leader = .Leader
                UnderElement = .UnderElement
                UnderColor = .UnderColor
                If (.Code Is Nothing) Then
                    Code = Nothing
                Else
                    Code = New CodeContainer(.Code.Code)
                End If
                CurrentInstruction = .CurrentInstruction
                Length = .Length
            End With
        End Sub

        Public ReadOnly Property Flow As Vector
            Get
                Return New Vector(XStep, YStep)
            End Get
        End Property

        Public Property Vector As Vector
            Get
                Return New Vector(XStep, YStep)
            End Get
            Set(ByVal value As Vector)
                With value
                    XStep = .X
                    YStep = .Y
                End With
            End Set
        End Property
    End Class
End Namespace