﻿Namespace Roton

    Public Structure AnsiChar
        Public [Char] As Byte
        Public [Color] As Byte

        Public Sub New(ByVal NewChar As Integer, ByVal NewColor As Integer)
            [Char] = CByte(NewChar And 255)
            [Color] = CByte(NewColor And 255)
        End Sub
    End Structure

    Public Interface Video
        Function CharAt(ByVal X As Integer, ByVal Y As Integer) As AnsiChar
        Sub ClearOverlay()
        Sub Plot(ByVal X As Integer, ByVal Y As Integer, ByVal AC As AnsiChar)
        Sub PlotOverlay(ByVal X As Integer, ByVal Y As Integer, ByVal AC As AnsiChar)
        Sub SetSize(ByVal W As Integer, ByVal H As Integer)
        Sub SetViewport(ByVal W As Integer, ByVal H As Integer)
        Sub Write(ByVal X As Integer, ByVal Y As Integer, ByVal S As String, ByVal Col As Integer)
        Sub WriteOverlay(ByVal X As Integer, ByVal Y As Integer, ByVal S As String, ByVal Col As Integer)
    End Interface

    Public Class VideoNull
        Implements Video

        Public Sub ClearOverlay() Implements Video.ClearOverlay
            Return
        End Sub

        Public Sub Plot(ByVal X As Integer, ByVal Y As Integer, ByVal AC As AnsiChar) Implements Video.Plot
            Return
        End Sub

        Public Sub PlotOverlay(ByVal X As Integer, ByVal Y As Integer, ByVal AC As AnsiChar) Implements Video.PlotOverlay
            Return
        End Sub

        Public Sub SetSize(ByVal W As Integer, ByVal H As Integer) Implements Video.SetSize
            Return
        End Sub

        Public Sub SetViewport(ByVal W As Integer, ByVal H As Integer) Implements Video.SetViewport
            Return
        End Sub

        Public Sub Write(ByVal X As Integer, ByVal Y As Integer, ByVal S As String, ByVal Col As Integer) Implements Video.Write
            Return
        End Sub

        Public Sub WriteOverlay(ByVal X As Integer, ByVal Y As Integer, ByVal S As String, ByVal Col As Integer) Implements Video.WriteOverlay
            Return
        End Sub

        Public Function CharAt(ByVal X As Integer, ByVal Y As Integer) As AnsiChar Implements Video.CharAt
            Return New AnsiChar(0, 0)
        End Function
    End Class
End Namespace